"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/formatQuery/index.ts
var formatQuery_exports = {};
__export(formatQuery_exports, {
  bigIntJsonParseReviver: () => bigIntJsonParseReviver,
  bigIntJsonStringifyReplacer: () => bigIntJsonStringifyReplacer,
  celCombinatorMap: () => celCombinatorMap,
  defaultCELValueProcessor: () => defaultCELValueProcessor,
  defaultExportOperatorMap: () => defaultExportOperatorMap,
  defaultMongoDBValueProcessor: () => defaultMongoDBValueProcessor,
  defaultNLTranslations: () => defaultNLTranslations,
  defaultOperatorProcessorNL: () => defaultOperatorProcessorNL,
  defaultOperatorProcessorSQL: () => defaultOperatorProcessorSQL,
  defaultRuleGroupProcessorCEL: () => defaultRuleGroupProcessorCEL,
  defaultRuleGroupProcessorDrizzle: () => defaultRuleGroupProcessorDrizzle,
  defaultRuleGroupProcessorElasticSearch: () => defaultRuleGroupProcessorElasticSearch,
  defaultRuleGroupProcessorJSONata: () => defaultRuleGroupProcessorJSONata,
  defaultRuleGroupProcessorJsonLogic: () => defaultRuleGroupProcessorJsonLogic,
  defaultRuleGroupProcessorLDAP: () => defaultRuleGroupProcessorLDAP,
  defaultRuleGroupProcessorMongoDB: () => defaultRuleGroupProcessorMongoDB,
  defaultRuleGroupProcessorMongoDBQuery: () => defaultRuleGroupProcessorMongoDBQuery,
  defaultRuleGroupProcessorNL: () => defaultRuleGroupProcessorNL,
  defaultRuleGroupProcessorParameterized: () => defaultRuleGroupProcessorParameterized,
  defaultRuleGroupProcessorPrisma: () => defaultRuleGroupProcessorPrisma,
  defaultRuleGroupProcessorSQL: () => defaultRuleGroupProcessorSQL,
  defaultRuleGroupProcessorSequelize: () => defaultRuleGroupProcessorSequelize,
  defaultRuleGroupProcessorSpEL: () => defaultRuleGroupProcessorSpEL,
  defaultRuleProcessorCEL: () => defaultRuleProcessorCEL,
  defaultRuleProcessorDrizzle: () => defaultRuleProcessorDrizzle,
  defaultRuleProcessorElasticSearch: () => defaultRuleProcessorElasticSearch,
  defaultRuleProcessorJSONata: () => defaultRuleProcessorJSONata,
  defaultRuleProcessorJsonLogic: () => defaultRuleProcessorJsonLogic,
  defaultRuleProcessorLDAP: () => defaultRuleProcessorLDAP,
  defaultRuleProcessorMongoDB: () => defaultRuleProcessorMongoDB,
  defaultRuleProcessorMongoDBQuery: () => defaultRuleProcessorMongoDBQuery,
  defaultRuleProcessorNL: () => defaultRuleProcessorNL,
  defaultRuleProcessorParameterized: () => defaultRuleProcessorParameterized,
  defaultRuleProcessorPrisma: () => defaultRuleProcessorPrisma,
  defaultRuleProcessorSQL: () => defaultRuleProcessorSQL,
  defaultRuleProcessorSequelize: () => defaultRuleProcessorSequelize,
  defaultRuleProcessorSpEL: () => defaultRuleProcessorSpEL,
  defaultSpELValueProcessor: () => defaultSpELValueProcessor,
  defaultValueProcessor: () => defaultValueProcessor,
  defaultValueProcessorByRule: () => defaultValueProcessorByRule,
  defaultValueProcessorCELByRule: () => defaultValueProcessorCELByRule,
  defaultValueProcessorMongoDBByRule: () => defaultValueProcessorMongoDBByRule,
  defaultValueProcessorNL: () => defaultValueProcessorNL,
  defaultValueProcessorSpELByRule: () => defaultValueProcessorSpELByRule,
  formatQuery: () => formatQuery,
  formatQueryOptionPresets: () => formatQueryOptionPresets,
  getNLTranslataion: () => getNLTranslataion,
  getQuoteFieldNamesWithArray: () => getQuoteFieldNamesWithArray,
  getQuotedFieldName: () => getQuotedFieldName,
  isValidValue: () => isValidValue,
  isValueProcessorLegacy: () => isValueProcessorLegacy,
  jsonLogicAdditionalOperators: () => jsonLogicAdditionalOperators,
  mapSQLOperator: () => mapSQLOperator,
  mongoDbFallback: () => mongoDbFallback,
  mongoOperators: () => mongoOperators,
  normalizeConstituentWordOrder: () => normalizeConstituentWordOrder,
  numerifyValues: () => numerifyValues,
  prismaFallback: () => prismaFallback,
  prismaOperators: () => prismaOperators,
  processMatchMode: () => processMatchMode,
  shouldRenderAsNumber: () => shouldRenderAsNumber,
  sqlDialectPresets: () => sqlDialectPresets
});
module.exports = __toCommonJS(formatQuery_exports);

// src/defaults.ts
var defaultPlaceholderName = "~";
var defaultPlaceholderFieldName = defaultPlaceholderName;
var defaultPlaceholderOperatorName = defaultPlaceholderName;
var defaultJoinChar = ",";
var defaultCombinators = [
  { name: "and", value: "and", label: "AND" },
  { name: "or", value: "or", label: "OR" }
];
var defaultCombinatorsExtended = [
  ...defaultCombinators,
  { name: "xor", value: "xor", label: "XOR" }
];

// src/utils/arrayUtils.ts
var splitBy = (str, splitChar = defaultJoinChar) => typeof str === "string" ? str.split(`\\${splitChar}`).map((c) => c.split(splitChar)).reduce((prev, curr, idx) => {
  if (idx === 0) {
    return curr;
  }
  return [...prev.slice(0, -1), `${prev.at(-1)}${splitChar}${curr[0]}`, ...curr.slice(1)];
}, []) : [];
var joinWith = (strArr, joinChar = defaultJoinChar) => strArr.map((str) => `${str ?? ""}`.replaceAll(joinChar[0], `\\${joinChar[0]}`)).join(joinChar);
var trimIfString = (val) => typeof val === "string" ? val.trim() : val;
var toArray = (v, { retainEmptyStrings } = {}) => Array.isArray(v) ? v.map((v2) => trimIfString(v2)) : typeof v === "string" ? splitBy(v, defaultJoinChar).filter(retainEmptyStrings ? () => true : (s) => !/^\s*$/.test(s)).map((s) => s.trim()) : typeof v === "number" ? [v] : [];

// src/utils/misc.ts
var import_numeric_quantity = require("numeric-quantity");
var lc = (v) => typeof v === "string" ? v.toLowerCase() : v;
var numericRegex = new RegExp(
  import_numeric_quantity.numericRegex.source.replace(/^\^/, String.raw`^\s*`).replace(/\$$/, String.raw`\s*$`)
);
var isPojo = (obj) => obj === null || typeof obj !== "object" ? false : Object.getPrototypeOf(obj) === Object.prototype;
var nullOrUndefinedOrEmpty = (value) => value === null || value === void 0 || value === "";

// src/utils/parseNumber.ts
var import_numeric_quantity2 = require("numeric-quantity");
var parseNumber = (val, { parseNumbers, bigIntOnOverflow } = {}) => {
  if (!parseNumbers || typeof val === "bigint" || typeof val === "number") {
    return val;
  }
  if (parseNumbers === "native") {
    return Number.parseFloat(val);
  }
  const valAsNum = (
    // TODO: Should these options be configurable?
    (0, import_numeric_quantity2.numericQuantity)(val, {
      allowTrailingInvalid: parseNumbers === "enhanced",
      bigIntOnOverflow,
      romanNumerals: false,
      round: false
    })
  );
  return typeof valAsNum === "bigint" || !Number.isNaN(valAsNum) ? valAsNum : val;
};

// src/utils/transformQuery.ts
var import_immer = require("immer");

// src/utils/isRuleGroup.ts
var isRuleGroup = (rg) => isPojo(rg) && Array.isArray(rg.rules);
var isRuleGroupType = (rg) => isRuleGroup(rg) && typeof rg.combinator === "string";
var isRuleGroupTypeIC = (rg) => isRuleGroup(rg) && rg.combinator === void 0;

// src/utils/transformQuery.ts
var remapProperties = (obj, propertyMap, deleteRemappedProperties) => (0, import_immer.produce)(obj, (draft) => {
  for (const [k, v] of Object.entries(propertyMap)) {
    if (v === false) {
      delete draft[k];
    } else if (!!v && k !== v && k in draft) {
      draft[v] = draft[k];
      if (deleteRemappedProperties) {
        delete draft[k];
      }
    }
  }
});
function transformQuery(query, options = {}) {
  const {
    ruleProcessor = (r) => r,
    ruleGroupProcessor = (rg) => rg,
    propertyMap = {},
    combinatorMap = {},
    operatorMap = {},
    omitPath = false,
    deleteRemappedProperties = true
  } = options;
  const processGroup = (rg) => ({
    ...ruleGroupProcessor(
      remapProperties(
        {
          ...rg,
          ...isRuleGroupType(rg) ? { combinator: combinatorMap[rg.combinator] ?? rg.combinator } : {}
        },
        propertyMap,
        deleteRemappedProperties
      )
    ),
    ...propertyMap["rules"] === false ? null : {
      // oxlint-disable-next-line typescript/no-explicit-any
      [propertyMap["rules"] ?? "rules"]: rg.rules.map((r, idx) => {
        const pathObject = omitPath ? null : { path: [...rg.path, idx] };
        if (typeof r === "string") {
          return combinatorMap[r] ?? r;
        } else if (isRuleGroup(r)) {
          return processGroup({ ...r, ...pathObject });
        }
        return ruleProcessor(
          remapProperties(
            {
              ...r,
              ...pathObject,
              ..."operator" in r ? { operator: operatorMap[r.operator] ?? r.operator } : {}
            },
            propertyMap,
            deleteRemappedProperties
          )
        );
      })
    }
  });
  return processGroup({ ...query, ...omitPath ? null : { path: [] } });
}

// src/utils/isRuleOrGroupValid.ts
var isValidationResult = (vr) => isPojo(vr) && typeof vr.valid === "boolean";
var isRuleOrGroupValid = (rg, validationResult, validator) => {
  if (typeof validationResult === "boolean") {
    return validationResult;
  }
  if (isValidationResult(validationResult)) {
    return validationResult.valid;
  }
  if (typeof validator === "function" && !isRuleGroup(rg)) {
    const vr = validator(rg);
    if (typeof vr === "boolean") {
      return vr;
    }
    if (isValidationResult(vr)) {
      return vr.valid;
    }
  }
  return true;
};

// src/utils/optGroupUtils.ts
var import_immer2 = require("immer");
var isOptionWithName = (opt) => isPojo(opt) && "name" in opt && typeof opt.name === "string";
var isOptionWithValue = (opt) => isPojo(opt) && "value" in opt && typeof opt.value === "string";
function toFullOption(opt, baseProperties, labelMap) {
  const recipe = (0, import_immer2.produce)((draft) => {
    const idObj = {};
    let needsUpdating = !!baseProperties;
    if (typeof draft === "string") {
      return {
        ...baseProperties,
        name: draft,
        value: draft,
        label: labelMap?.[draft] ?? draft
      };
    }
    if (isOptionWithName(draft) && !isOptionWithValue(draft)) {
      idObj.value = draft.name;
      needsUpdating = true;
    } else if (!isOptionWithName(draft) && isOptionWithValue(draft)) {
      idObj.name = draft.value;
      needsUpdating = true;
    }
    if (needsUpdating) {
      return Object.assign({}, baseProperties, draft, idObj);
    }
  });
  return recipe(opt);
}
function toFullOptionList(optList, baseProperties, labelMap) {
  if (!Array.isArray(optList)) {
    return [];
  }
  const recipe = (0, import_immer2.produce)((draft) => {
    if (isFlexibleOptionGroupArray(draft)) {
      for (const optGroup of draft) {
        for (const [idx, opt] of optGroup.options.entries())
          optGroup.options[idx] = toFullOption(opt, baseProperties, labelMap);
      }
    } else {
      for (const [idx, opt] of draft.entries())
        draft[idx] = toFullOption(opt, baseProperties, labelMap);
    }
  });
  return recipe(optList);
}
var uniqByIdentifier = (originalArray) => {
  const names = /* @__PURE__ */ new Set();
  const newArray = [];
  for (const el of originalArray) {
    if (!names.has(el.value ?? el.name)) {
      names.add(el.value ?? el.name);
      newArray.push(el);
    }
  }
  return originalArray.length === newArray.length ? originalArray : newArray;
};
var isOptionGroupArray = (arr) => Array.isArray(arr) && arr.length > 0 && isPojo(arr[0]) && "options" in arr[0] && Array.isArray(arr[0].options);
var isFlexibleOptionArray = (arr) => {
  let isFOA = false;
  if (Array.isArray(arr)) {
    for (const o of arr) {
      if (isOptionWithName(o) || isOptionWithValue(o)) {
        isFOA = true;
      } else {
        return false;
      }
    }
  }
  return isFOA;
};
var isFlexibleOptionGroupArray = (arr, { allowEmpty = false } = {}) => {
  let isFOGA = false;
  if (Array.isArray(arr)) {
    for (const og of arr) {
      if (isPojo(og) && "options" in og && (isFlexibleOptionArray(og.options) || allowEmpty && Array.isArray(og.options) && og.options.length === 0)) {
        isFOGA = true;
      } else {
        return false;
      }
    }
  }
  return isFOGA;
};
var getOption = (arr, name) => (isFlexibleOptionGroupArray(arr, { allowEmpty: true }) ? arr.flatMap((og) => og.options) : arr).find((op) => op.value === name || op.name === name);
var toFlatOptionArray = (arr) => uniqByIdentifier(isOptionGroupArray(arr) ? arr.flatMap((og) => og.options) : arr);

// src/utils/getParseNumberMethod.ts
var getParseNumberMethod = ({
  parseNumbers,
  inputType
}) => {
  if (typeof parseNumbers === "string") {
    const [method, level] = parseNumbers.split("-");
    if (level === "limited") {
      return inputType === "number" ? method : false;
    }
    return method;
  }
  return parseNumbers ? "strict" : false;
};

// src/utils/formatQuery/utils.ts
var mapSQLOperator = (rqbOperator) => {
  switch (lc(rqbOperator)) {
    case "null":
      return "is null";
    case "notnull":
      return "is not null";
    case "notin":
      return "not in";
    case "notbetween":
      return "not between";
    case "contains":
    case "beginswith":
    case "endswith":
      return "like";
    case "doesnotcontain":
    case "doesnotbeginwith":
    case "doesnotendwith":
      return "not like";
    default:
      return rqbOperator;
  }
};
var mongoOperators = {
  "=": "$eq",
  "!=": "$ne",
  "<": "$lt",
  "<=": "$lte",
  ">": "$gt",
  ">=": "$gte",
  in: "$in",
  notin: "$nin",
  notIn: "$nin"
  // only here for backwards compatibility
};
var prismaOperators = {
  "=": "equals",
  "!=": "not",
  "<": "lt",
  "<=": "lte",
  ">": "gt",
  ">=": "gte",
  in: "in",
  notin: "notIn"
};
var celCombinatorMap = {
  and: "&&",
  or: "||"
};
var jsonLogicAdditionalOperators = {
  startsWith: (a, b) => typeof a === "string" && a.startsWith(b),
  endsWith: (a, b) => typeof a === "string" && a.endsWith(b)
};
var numerifyValues = (rg, options) => ({
  ...rg,
  // @ts-expect-error TS doesn't keep track of odd/even indexes here
  rules: rg.rules.map((r) => {
    if (typeof r === "string") {
      return r;
    }
    if (isRuleGroup(r)) {
      return numerifyValues(r, options);
    }
    const fieldData = getOption(options.fields, r.field);
    const parseNumbers = getParseNumberMethod({
      parseNumbers: options.parseNumbers,
      inputType: fieldData?.inputType
    });
    if (Array.isArray(r.value)) {
      return { ...r, value: r.value.map((v) => parseNumber(v, { parseNumbers })) };
    }
    const valAsArray = toArray(r.value, { retainEmptyStrings: true }).map(
      (v) => parseNumber(v, { parseNumbers })
    );
    if (valAsArray.every((v) => typeof v === "number")) {
      if (valAsArray.length > 1) {
        return { ...r, value: valAsArray };
      } else if (valAsArray.length === 1) {
        return { ...r, value: valAsArray[0] };
      }
    }
    return r;
  })
});
var isValidValue = (value) => typeof value === "string" && value.length > 0 || typeof value === "number" && !Number.isNaN(value) || typeof value !== "string" && typeof value !== "number";
var shouldRenderAsNumber = (value, parseNumbers) => !!parseNumbers && (typeof value === "number" || typeof value === "bigint" || typeof value === "string" && numericRegex.test(value));
var isValueProcessorLegacy = (valueProcessor) => valueProcessor.length >= 3;
var getQuoteFieldNamesWithArray = (quoteFieldNamesWith = ["", ""]) => Array.isArray(quoteFieldNamesWith) ? quoteFieldNamesWith : typeof quoteFieldNamesWith === "string" ? [quoteFieldNamesWith, quoteFieldNamesWith] : quoteFieldNamesWith ?? ["", ""];
var getQuotedFieldName = (fieldName, { quoteFieldNamesWith, fieldIdentifierSeparator }) => {
  const [qPre, qPost] = getQuoteFieldNamesWithArray(quoteFieldNamesWith);
  return typeof fieldIdentifierSeparator === "string" && fieldIdentifierSeparator.length > 0 ? joinWith(
    splitBy(fieldName, fieldIdentifierSeparator).map((part) => `${qPre}${part}${qPost}`),
    fieldIdentifierSeparator
  ) : `${qPre}${fieldName}${qPost}`;
};
var defaultWordOrder = ["S", "V", "O"];
var normalizeConstituentWordOrder = (input) => {
  const result = [];
  const letterSet = new Set(defaultWordOrder);
  for (const char of input.toUpperCase()) {
    if (letterSet.has(char)) {
      result.push(char);
      letterSet.delete(char);
      if (letterSet.size === 0) break;
    }
  }
  for (const letter of defaultWordOrder) {
    if (letterSet.has(letter)) {
      result.push(letter);
    }
  }
  return result;
};
var defaultNLTranslations = {
  // and: 'and',
  // or: 'or',
  // true: 'true',
  // false: 'false',
  groupPrefix: "",
  // groupPrefix_not: '',
  groupPrefix_not_xor: "either zero or more than one of",
  groupPrefix_xor: "exactly one of",
  groupSuffix: "is true",
  groupSuffix_not: "is not true"
  // groupSuffix_not_xor: 'is true',
  // groupSuffix_xor: 'is true',
};
var translationMatchFilter = (key, keyToTest, conditions) => (
  // The translation matches the base key
  keyToTest.startsWith(key) && // The translation specifies all conditions
  conditions.every(
    (c) => (
      // This translation specifies _this_ condition
      keyToTest.includes(`_${c}`) && // This translation specifies the same _total number_ of conditions
      keyToTest.match(/_/g)?.length === conditions.length
    )
  )
);
var getNLTranslataion = (key, translations, conditions = []) => conditions.length === 0 ? translations[key] ?? defaultNLTranslations[key] ?? /* istanbul ignore next */
"" : Object.entries(translations).find(
  ([keyToTest]) => translationMatchFilter(key, keyToTest, conditions)
)?.[1] ?? Object.entries(defaultNLTranslations).find(
  ([keyToTest]) => translationMatchFilter(key, keyToTest, conditions)
)?.[1] ?? defaultNLTranslations[key] ?? /* istanbul ignore next */
"";
var processMatchMode = (rule) => {
  const { mode, threshold } = rule.match ?? {};
  if (mode) {
    if (!isRuleGroup(rule.value)) return false;
    const matchModeLC = lc(mode);
    const matchModeCoerced = matchModeLC === "atleast" && threshold === 1 ? "some" : matchModeLC === "atmost" && threshold === 0 ? "none" : matchModeLC;
    if ((matchModeCoerced === "atleast" || matchModeCoerced === "atmost" || matchModeCoerced === "exactly") && (typeof threshold !== "number" || threshold < 0)) {
      return false;
    }
    return { mode: matchModeCoerced, threshold };
  }
};
var bigIntJsonStringifyReplacer = (_key, value) => typeof value === "bigint" ? { $bigint: value.toString() } : value;
var bigIntJsonParseReviver = (_key, value) => isPojo(value) && Object.keys(value).length === 1 && typeof value.$bigint === "string" ? BigInt(value.$bigint) : value;

// src/utils/formatQuery/defaultRuleGroupProcessorCEL.ts
var defaultRuleGroupProcessorCEL = (ruleGroup, options) => {
  const {
    fields,
    fallbackExpression,
    getParseNumberBoolean,
    placeholderFieldName,
    placeholderOperatorName,
    placeholderValueName,
    ruleProcessor,
    validateRule,
    validationMap
  } = options;
  const processRuleGroup = (rg, outermost) => {
    if (!isRuleOrGroupValid(rg, validationMap[rg.id ?? /* istanbul ignore next */
    ""])) {
      return outermost ? fallbackExpression : "";
    }
    const expression = rg.rules.map((rule) => {
      if (typeof rule === "string") {
        return celCombinatorMap[rule];
      }
      if (isRuleGroup(rule)) {
        return processRuleGroup(rule);
      }
      const [validationResult, fieldValidator] = validateRule(rule);
      if (!isRuleOrGroupValid(rule, validationResult, fieldValidator) || rule.field === placeholderFieldName || rule.operator === placeholderOperatorName || /* istanbul ignore next */
      placeholderValueName !== void 0 && rule.value === placeholderValueName) {
        return "";
      }
      const fieldData = getOption(fields, rule.field);
      return ruleProcessor(rule, {
        ...options,
        parseNumbers: getParseNumberBoolean(fieldData?.inputType),
        escapeQuotes: (rule.valueSource ?? "value") === "value",
        fieldData
      });
    }).filter(Boolean).join(
      isRuleGroupType(rg) ? ` ${celCombinatorMap[rg.combinator]} ` : " "
    );
    const [prefix, suffix] = rg.not || !outermost ? [`${rg.not ? "!" : ""}(`, ")"] : ["", ""];
    return expression ? `${prefix}${expression}${suffix}` : fallbackExpression;
  };
  return processRuleGroup(ruleGroup, true);
};

// src/utils/formatQuery/defaultRuleProcessorCEL.ts
var shouldNegate = (op) => op.startsWith("not") || op.startsWith("doesnot");
var escapeDoubleQuotes = (v, escapeQuotes) => typeof v !== "string" || !escapeQuotes ? v : v.replaceAll(`"`, `\\"`);
var defaultRuleProcessorCEL = (rule, opts = {}) => {
  const { escapeQuotes, parseNumbers, preserveValueOrder } = opts;
  const { field, operator, value, valueSource } = rule;
  const valueIsField = valueSource === "field";
  const operatorTL = lc(operator === "=" ? "==" : operator);
  const useBareValue = typeof value === "number" || typeof value === "boolean" || typeof value === "bigint" || shouldRenderAsNumber(value, parseNumbers);
  const matchEval = processMatchMode(rule);
  if (matchEval === false) {
    return "";
  } else if (matchEval) {
    const { mode, threshold } = matchEval;
    const arrayElementAlias = "elem_alias";
    const celQuery = transformQuery(rule.value, {
      ruleProcessor: (r) => ({ ...r, field: `${arrayElementAlias}${r.field ? `.${r.field}` : ""}` })
    });
    const nestedArrayFilter = defaultRuleGroupProcessorCEL(
      celQuery,
      opts
    );
    switch (mode) {
      case "all":
        return `${field}.all(${arrayElementAlias}, ${nestedArrayFilter})`;
      case "none":
      case "some":
        return `${mode === "none" ? "!" : ""}${field}.exists(${arrayElementAlias}, ${nestedArrayFilter})`;
      case "atleast":
      case "atmost":
      case "exactly": {
        const totalCount = `double(${field}.size())`;
        const filteredCount = `${field}.filter(${arrayElementAlias}, ${nestedArrayFilter}).size()`;
        const op = mode === "atleast" ? ">=" : mode === "atmost" ? "<=" : "==";
        if (threshold > 0 && threshold < 1) {
          return `${filteredCount} ${op} (${totalCount} * ${threshold})`;
        }
        return `${filteredCount} ${op} ${threshold}`;
      }
    }
  }
  switch (operatorTL) {
    case "<":
    case "<=":
    case "==":
    case "!=":
    case ">":
    case ">=":
      return `${field} ${operatorTL} ${valueIsField || useBareValue ? trimIfString(value) : `"${escapeDoubleQuotes(value, escapeQuotes)}"`}`;
    case "contains":
    case "doesnotcontain": {
      const negate2 = shouldNegate(operatorTL) ? "!" : "";
      return `${negate2}${field}.contains(${valueIsField ? trimIfString(value) : `"${escapeDoubleQuotes(value, escapeQuotes)}"`})`;
    }
    case "beginswith":
    case "doesnotbeginwith": {
      const negate2 = shouldNegate(operatorTL) ? "!" : "";
      return `${negate2}${field}.startsWith(${valueIsField ? trimIfString(value) : `"${escapeDoubleQuotes(value, escapeQuotes)}"`})`;
    }
    case "endswith":
    case "doesnotendwith": {
      const negate2 = shouldNegate(operatorTL) ? "!" : "";
      return `${negate2}${field}.endsWith(${valueIsField ? trimIfString(value) : `"${escapeDoubleQuotes(value, escapeQuotes)}"`})`;
    }
    case "null":
      return `${field} == null`;
    case "notnull":
      return `${field} != null`;
    case "in":
    case "notin": {
      const [prefix, suffix] = shouldNegate(operatorTL) ? ["!(", ")"] : ["", ""];
      const valueAsArray = toArray(value);
      return `${prefix}${field} in [${valueAsArray.map(
        (val) => valueIsField || shouldRenderAsNumber(val, parseNumbers) ? `${trimIfString(val)}` : `"${escapeDoubleQuotes(val, escapeQuotes)}"`
      ).join(", ")}]${suffix}`;
    }
    case "between":
    case "notbetween": {
      const valueAsArray = toArray(value);
      if (valueAsArray.length >= 2 && !nullOrUndefinedOrEmpty(valueAsArray[0]) && !nullOrUndefinedOrEmpty(valueAsArray[1])) {
        const [first, second] = valueAsArray;
        const shouldParseNumbers = !(parseNumbers === false);
        const firstNum = shouldRenderAsNumber(first, shouldParseNumbers) ? parseNumber(first, { parseNumbers: shouldParseNumbers }) : Number.NaN;
        const secondNum = shouldRenderAsNumber(second, shouldParseNumbers) ? parseNumber(second, { parseNumbers: shouldParseNumbers }) : Number.NaN;
        let firstValue = Number.isNaN(firstNum) ? valueIsField ? `${first}` : `"${escapeDoubleQuotes(first, escapeQuotes)}"` : firstNum;
        let secondValue = Number.isNaN(secondNum) ? valueIsField ? `${second}` : `"${escapeDoubleQuotes(second, escapeQuotes)}"` : secondNum;
        if (!preserveValueOrder && firstValue === firstNum && secondValue === secondNum && secondNum < firstNum) {
          const tempNum = secondNum;
          secondValue = firstNum;
          firstValue = tempNum;
        }
        return operatorTL === "between" ? `(${field} >= ${firstValue} && ${field} <= ${secondValue})` : `(${field} < ${firstValue} || ${field} > ${secondValue})`;
      } else {
        return "";
      }
    }
  }
  return "";
};

// src/utils/convertQuery.ts
var import_immer3 = require("immer");
var combinatorLevels = ["or", "xor", "and"];
var isSameString = (a, b) => lc(a) === b;
var generateRuleGroupICWithConsistentCombinators = (rg, baseCombinatorLevel = 0) => {
  const baseCombinator = combinatorLevels[baseCombinatorLevel];
  if (!rg.rules.includes(baseCombinator)) {
    return baseCombinatorLevel < combinatorLevels.length - 2 ? generateRuleGroupICWithConsistentCombinators(rg, baseCombinatorLevel + 1) : rg;
  }
  return (0, import_immer3.produce)(rg, (draft) => {
    let cursor = 0;
    while (cursor < draft.rules.length - 2) {
      if (isSameString(draft.rules[cursor + 1], baseCombinator)) {
        cursor += 2;
        continue;
      }
      const nextBaseCombinatorIndex = draft.rules.findIndex(
        (r, i) => i > cursor && typeof r === "string" && lc(r) === baseCombinator
      );
      if (nextBaseCombinatorIndex === -1) {
        draft.rules.splice(
          cursor,
          draft.rules.length,
          generateRuleGroupICWithConsistentCombinators(
            // oxlint-disable-next-line typescript/no-explicit-any
            { rules: draft.rules.slice(cursor) },
            baseCombinatorLevel + 1
          )
        );
        break;
      } else {
        draft.rules.splice(
          cursor,
          nextBaseCombinatorIndex - cursor,
          generateRuleGroupICWithConsistentCombinators(
            // oxlint-disable-next-line typescript/no-explicit-any
            { rules: draft.rules.slice(cursor, nextBaseCombinatorIndex) },
            baseCombinatorLevel + 1
          )
        );
      }
    }
  });
};
var convertFromIC = (rg) => {
  if (isRuleGroupType(rg)) {
    return rg;
  }
  const processedRG = generateRuleGroupICWithConsistentCombinators(rg);
  const rulesAsMixedList = processedRG.rules.map(
    (r) => typeof r === "string" || !isRuleGroup(r) ? r : convertFromIC(r)
  );
  const combinator = rulesAsMixedList.length < 2 ? "and" : rulesAsMixedList[1];
  const rules = rulesAsMixedList.filter((r) => typeof r !== "string");
  return { ...processedRG, combinator, rules };
};

// src/utils/formatQuery/defaultRuleGroupProcessorMongoDBQuery.ts
var mongoDbFallback = { $and: [{ $expr: true }] };
var defaultRuleGroupProcessorMongoDBQuery = (ruleGroup, options, meta) => {
  const {
    fields,
    getParseNumberBoolean,
    placeholderFieldName,
    placeholderOperatorName,
    placeholderValueName,
    ruleProcessor,
    validateRule,
    validationMap
  } = options;
  const processRuleGroup = (rg, outermost) => {
    if (!isRuleOrGroupValid(rg, validationMap[rg.id ?? /* istanbul ignore next */
    ""])) {
      return outermost ? mongoDbFallback : false;
    }
    const combinator = `$${lc(rg.combinator)}`;
    let hasChildRules = false;
    const expressions = rg.rules.map((rule) => {
      if (isRuleGroup(rule)) {
        const processedRuleGroup = processRuleGroup(rule);
        if (processedRuleGroup) {
          hasChildRules = true;
          return processedRuleGroup;
        }
        return false;
      }
      const [validationResult, fieldValidator] = validateRule(rule);
      if (!isRuleOrGroupValid(rule, validationResult, fieldValidator) || rule.field === placeholderFieldName || rule.operator === placeholderOperatorName || /* istanbul ignore next */
      placeholderValueName !== void 0 && rule.value === placeholderValueName) {
        return false;
      }
      const fieldData = getOption(fields, rule.field);
      return ruleProcessor(
        rule,
        {
          ...options,
          parseNumbers: getParseNumberBoolean(fieldData?.inputType),
          fieldData
        },
        meta
      );
    }).filter(Boolean);
    return expressions.length > 0 ? expressions.length === 1 && !hasChildRules ? expressions[0] : { [combinator]: expressions } : mongoDbFallback;
  };
  return processRuleGroup(convertFromIC(ruleGroup), true);
};

// src/utils/formatQuery/defaultRuleProcessorMongoDBQuery.ts
var processNumber = (value, fallback, parseNumbers = false) => shouldRenderAsNumber(value, parseNumbers || typeof value === "bigint") ? Number(parseNumber(value, { parseNumbers: "strict" })) : fallback;
var defaultRuleProcessorMongoDBQuery = (rule, options = {}) => {
  const { field, operator, value, valueSource } = rule;
  const { parseNumbers, preserveValueOrder, context } = options;
  const valueIsField = valueSource === "field";
  const { avoidFieldsAsKeys } = context ?? {};
  const matchEval = processMatchMode(rule);
  if (matchEval === false) {
    return;
  } else if (matchEval) {
    const { mode, threshold } = matchEval;
    const totalCount = { $size: { $ifNull: [`$${field}`, []] } };
    const subQueryNoAggCtx = defaultRuleGroupProcessorMongoDBQuery(
      transformQuery(value, {
        ruleProcessor: (r) => ({ ...r, field: r.field ? `${field}.${r.field}` : field })
      }),
      {
        ...options,
        // We have to override `ruleProcessor` in case original `format` is "mongodb"
        ruleProcessor: defaultRuleProcessorMongoDBQuery,
        context: { ...options.context, avoidFieldsAsKeys: false }
      }
    );
    const subQueryWithAggCtx = defaultRuleGroupProcessorMongoDBQuery(
      transformQuery(value, {
        ruleProcessor: (r) => ({ ...r, field: r.field ? `$item.${r.field}` : "$item" })
      }),
      {
        ...options,
        // We have to override `ruleProcessor` in case original `format` is "mongodb"
        ruleProcessor: defaultRuleProcessorMongoDBQuery,
        context: { ...options.context, avoidFieldsAsKeys: true }
      }
    );
    const filteredCount = {
      $size: {
        $ifNull: [
          { $filter: { input: `$${field}`, as: "item", cond: { $and: [subQueryWithAggCtx] } } },
          []
        ]
      }
    };
    switch (mode) {
      case "all":
        return { $expr: { $eq: [filteredCount, totalCount] } };
      case "none":
        return { $nor: [subQueryNoAggCtx] };
      case "some":
        return subQueryNoAggCtx;
      case "atleast":
      case "atmost":
      case "exactly": {
        const op = mode === "atleast" ? mongoOperators[">="] : mode === "atmost" ? mongoOperators["<="] : mongoOperators["="];
        if (threshold > 0 && threshold < 1) {
          return { $expr: { [op]: [filteredCount, { $multiply: [totalCount, threshold] }] } };
        }
        return { $expr: { [op]: [filteredCount, threshold] } };
      }
    }
  }
  if (operator === "=" && !valueIsField) {
    return avoidFieldsAsKeys ? { $eq: [`$${field}`, processNumber(value, value, parseNumbers)] } : { [field]: processNumber(value, value, parseNumbers) };
  }
  const operatorLC = lc(operator);
  switch (operatorLC) {
    case "<":
    case "<=":
    case "=":
    case "!=":
    case ">":
    case ">=": {
      const mongoOperator = mongoOperators[operatorLC];
      return valueIsField ? { [mongoOperator]: [`$${field}`, `$${value}`] } : avoidFieldsAsKeys ? {
        $and: [
          { $ne: [`$${field}`, null] },
          { [mongoOperator]: [`$${field}`, processNumber(value, value, parseNumbers)] }
        ]
      } : { [field]: { [mongoOperator]: processNumber(value, value, parseNumbers) } };
    }
    case "contains":
      return valueIsField ? { $where: `this.${field}.includes(this.${value})` } : avoidFieldsAsKeys ? { $regexMatch: { input: `$${field}`, regex: value } } : { [field]: { $regex: value } };
    case "beginswith":
      return valueIsField ? { $where: `this.${field}.startsWith(this.${value})` } : avoidFieldsAsKeys ? { $regexMatch: { input: `$${field}`, regex: `^${value}` } } : { [field]: { $regex: `^${value}` } };
    case "endswith":
      return valueIsField ? { $where: `this.${field}.endsWith(this.${value})` } : avoidFieldsAsKeys ? { $regexMatch: { input: `$${field}`, regex: `${value}$` } } : { [field]: { $regex: `${value}$` } };
    case "doesnotcontain":
      return valueIsField ? { $where: `!this.${field}.includes(this.${value})` } : avoidFieldsAsKeys ? { $not: { $regexMatch: { input: `$${field}`, regex: value } } } : { [field]: { $not: { $regex: value } } };
    case "doesnotbeginwith":
      return valueIsField ? { $where: `!this.${field}.startsWith(this.${value})` } : avoidFieldsAsKeys ? { $not: { $regexMatch: { input: `$${field}`, regex: `^${value}` } } } : { [field]: { $not: { $regex: `^${value}` } } };
    case "doesnotendwith":
      return valueIsField ? { $where: `!this.${field}.endsWith(this.${value})` } : avoidFieldsAsKeys ? { $not: { $regexMatch: { input: `$${field}`, regex: `${value}$` } } } : { [field]: { $not: { $regex: `${value}$` } } };
    case "null":
      return avoidFieldsAsKeys ? { $eq: [`$${field}`, null] } : { [field]: null };
    case "notnull":
      return avoidFieldsAsKeys ? { $ne: [`$${field}`, null] } : { [field]: { $ne: null } };
    case "in":
    case "notin": {
      const valueAsArray = toArray(value);
      return valueIsField ? {
        $where: `${operatorLC === "notin" ? "!" : ""}[${valueAsArray.map((val) => `this.${val}`).join(",")}].includes(this.${field})`
      } : avoidFieldsAsKeys ? operatorLC === "notin" ? {
        $not: {
          [mongoOperators.in]: [
            `$${field}`,
            valueAsArray.map((val) => processNumber(val, val, parseNumbers))
          ]
        }
      } : {
        [mongoOperators[operatorLC]]: [
          `$${field}`,
          valueAsArray.map((val) => processNumber(val, val, parseNumbers))
        ]
      } : {
        [field]: {
          [mongoOperators[operatorLC]]: valueAsArray.map(
            (val) => processNumber(val, val, parseNumbers)
          )
        }
      };
    }
    case "between":
    case "notbetween": {
      const valueAsArray = toArray(value);
      if (valueAsArray.length >= 2 && isValidValue(valueAsArray[0]) && isValidValue(valueAsArray[1])) {
        const [first, second] = valueAsArray;
        const firstNum = processNumber(first, Number.NaN, true);
        const secondNum = processNumber(second, Number.NaN, true);
        let firstValue = valueIsField ? first : Number.isNaN(firstNum) ? first : firstNum;
        let secondValue = valueIsField ? second : Number.isNaN(secondNum) ? second : secondNum;
        if (!preserveValueOrder && firstValue === firstNum && secondValue === secondNum && secondNum < firstNum) {
          const tempNum = secondNum;
          secondValue = firstNum;
          firstValue = tempNum;
        }
        if (operatorLC === "between") {
          return valueIsField ? { $gte: [`$${field}`, `$${firstValue}`], $lte: [`$${field}`, `$${secondValue}`] } : avoidFieldsAsKeys ? {
            $and: [{ $gte: [`$${field}`, firstValue] }, { $lte: [`$${field}`, secondValue] }]
          } : { [field]: { $gte: firstValue, $lte: secondValue } };
        } else {
          return valueIsField ? {
            $or: [
              { $lt: [`$${field}`, `$${firstValue}`] },
              { $gt: [`$${field}`, `$${secondValue}`] }
            ]
          } : avoidFieldsAsKeys ? {
            $or: [{ $lt: [`$${field}`, firstValue] }, { $gt: [`$${field}`, secondValue] }]
          } : { $or: [{ [field]: { $lt: firstValue } }, { [field]: { $gt: secondValue } }] };
        }
      } else {
        return "";
      }
    }
  }
  return "";
};

// src/utils/formatQuery/defaultRuleProcessorMongoDB.ts
var defaultRuleProcessorMongoDB = (rule, options) => {
  const queryObj = defaultRuleProcessorMongoDBQuery(rule, options);
  return queryObj ? JSON.stringify(queryObj) : "";
};

// src/utils/formatQuery/defaultRuleGroupProcessorSpEL.ts
var defaultRuleGroupProcessorSpEL = (ruleGroup, options) => {
  const {
    fields,
    fallbackExpression,
    getParseNumberBoolean,
    placeholderFieldName,
    placeholderOperatorName,
    placeholderValueName,
    ruleProcessor,
    validateRule,
    validationMap
  } = options;
  const processRuleGroup = (rg, outermost) => {
    if (!isRuleOrGroupValid(rg, validationMap[rg.id ?? /* istanbul ignore next */
    ""])) {
      return outermost ? fallbackExpression : "";
    }
    const expression = rg.rules.map((rule) => {
      if (typeof rule === "string") {
        return rule;
      }
      if (isRuleGroup(rule)) {
        return processRuleGroup(rule);
      }
      const [validationResult, fieldValidator] = validateRule(rule);
      if (!isRuleOrGroupValid(rule, validationResult, fieldValidator) || rule.field === placeholderFieldName || rule.operator === placeholderOperatorName || /* istanbul ignore next */
      placeholderValueName !== void 0 && rule.value === placeholderValueName) {
        return "";
      }
      const fieldData = getOption(fields, rule.field);
      return ruleProcessor(rule, {
        ...options,
        parseNumbers: getParseNumberBoolean(fieldData?.inputType),
        escapeQuotes: (rule.valueSource ?? "value") === "value",
        fieldData
      });
    }).filter(Boolean).join(isRuleGroupType(rg) ? ` ${rg.combinator} ` : " ");
    const [prefix, suffix] = rg.not || !outermost ? [`${rg.not ? "!" : ""}(`, ")"] : ["", ""];
    return expression ? `${prefix}${expression}${suffix}` : fallbackExpression;
  };
  return processRuleGroup(ruleGroup, true);
};

// src/utils/formatQuery/defaultRuleProcessorSpEL.ts
var shouldNegate2 = (op) => op.startsWith("not") || op.startsWith("doesnot");
var wrapInNegation = (clause, negate2) => negate2 ? `!(${clause})` : `${clause}`;
var escapeSingleQuotes = (v, escapeQuotes) => typeof v !== "string" || !escapeQuotes ? v : v.replaceAll(`'`, `\\'`);
var defaultRuleProcessorSpEL = (rule, opts = {}) => {
  const { field, operator, value, valueSource } = rule;
  const { escapeQuotes, parseNumbers, preserveValueOrder } = opts;
  const valueIsField = valueSource === "field";
  const operatorTL = lc(operator === "=" ? "==" : operator);
  const useBareValue = typeof value === "number" || typeof value === "boolean" || typeof value === "bigint" || shouldRenderAsNumber(value, parseNumbers);
  const matchEval = processMatchMode(rule);
  if (matchEval === false) {
    return "";
  } else if (matchEval) {
    const { mode, threshold } = matchEval;
    const nestedArrayFilter = defaultRuleGroupProcessorSpEL(
      transformQuery(rule.value, {
        ruleProcessor: (r) => ({ ...r, field: `${r.field || "#this"}` })
      }),
      opts
    );
    const totalCount = `${field}.size()`;
    const filteredCount = `${field}.?[${nestedArrayFilter}].size()`;
    switch (mode) {
      case "all":
        return `${filteredCount} == ${totalCount}`;
      case "none":
        return `${filteredCount} == 0`;
      case "some":
        return `${filteredCount} >= 1`;
      case "atleast":
      case "atmost":
      case "exactly": {
        const op = mode === "atleast" ? ">=" : mode === "atmost" ? "<=" : "==";
        if (threshold > 0 && threshold < 1) {
          return `${filteredCount} ${op} (${totalCount} * ${threshold})`;
        }
        return `${filteredCount} ${op} ${threshold}`;
      }
    }
  }
  switch (operatorTL) {
    case "<":
    case "<=":
    case "==":
    case "!=":
    case ">":
    case ">=":
      return `${field} ${operatorTL} ${valueIsField || useBareValue ? trimIfString(value) : `'${escapeSingleQuotes(value, escapeQuotes)}'`}`;
    case "contains":
    case "doesnotcontain":
      return wrapInNegation(
        `${field} matches ${valueIsField || useBareValue ? trimIfString(value) : `'${escapeSingleQuotes(value, escapeQuotes)}'`}`,
        shouldNegate2(operatorTL)
      );
    case "beginswith":
    case "doesnotbeginwith": {
      const valueTL = valueIsField ? `'^'.concat(${trimIfString(value)})` : `'${typeof value === "string" && !value.startsWith("^") || useBareValue ? "^" : ""}${escapeSingleQuotes(value, escapeQuotes)}'`;
      return wrapInNegation(`${field} matches ${valueTL}`, shouldNegate2(operatorTL));
    }
    case "endswith":
    case "doesnotendwith": {
      const valueTL = valueIsField ? `${trimIfString(value)}.concat('$')` : `'${escapeSingleQuotes(value, escapeQuotes)}${typeof value === "string" && !value.endsWith("$") || useBareValue ? "$" : ""}'`;
      return wrapInNegation(`${field} matches ${valueTL}`, shouldNegate2(operatorTL));
    }
    case "null":
      return `${field} == null`;
    case "notnull":
      return `${field} != null`;
    case "in":
    case "notin": {
      const negate2 = shouldNegate2(operatorTL) ? "!" : "";
      const valueAsArray = toArray(value);
      return valueAsArray.length > 0 ? `${negate2}(${valueAsArray.map(
        (val) => `${field} == ${valueIsField || shouldRenderAsNumber(val, parseNumbers) ? `${trimIfString(val)}` : `'${escapeSingleQuotes(val, escapeQuotes)}'`}`
      ).join(" or ")})` : "";
    }
    case "between":
    case "notbetween": {
      const valueAsArray = toArray(value);
      if (valueAsArray.length >= 2 && !nullOrUndefinedOrEmpty(valueAsArray[0]) && !nullOrUndefinedOrEmpty(valueAsArray[1])) {
        const [first, second] = valueAsArray;
        const shouldParseNumbers = !(parseNumbers === false);
        const firstNum = shouldRenderAsNumber(first, shouldParseNumbers) ? parseNumber(first, { parseNumbers: shouldParseNumbers }) : Number.NaN;
        const secondNum = shouldRenderAsNumber(second, shouldParseNumbers) ? parseNumber(second, { parseNumbers: shouldParseNumbers }) : Number.NaN;
        let firstValue = Number.isNaN(firstNum) ? valueIsField ? `${first}` : `'${escapeSingleQuotes(first, escapeQuotes)}'` : firstNum;
        let secondValue = Number.isNaN(secondNum) ? valueIsField ? `${second}` : `'${escapeSingleQuotes(second, escapeQuotes)}'` : secondNum;
        if (!preserveValueOrder && firstValue === firstNum && secondValue === secondNum && secondNum < firstNum) {
          const tempNum = secondNum;
          secondValue = firstNum;
          firstValue = tempNum;
        }
        return operatorTL === "between" ? `(${field} >= ${firstValue} and ${field} <= ${secondValue})` : `(${field} < ${firstValue} or ${field} > ${secondValue})`;
      } else {
        return "";
      }
    }
  }
  return "";
};

// src/utils/formatQuery/defaultValueProcessorByRule.ts
var escapeStringValueQuotes = (v, quoteChar, escapeQuotes) => escapeQuotes && typeof v === "string" ? v.replaceAll(`${quoteChar}`, `${quoteChar}${quoteChar}`) : v;
var defaultValueProcessorByRule = ({ operator, value, valueSource }, {
  escapeQuotes,
  parseNumbers,
  preserveValueOrder,
  quoteFieldNamesWith,
  quoteValuesWith,
  concatOperator = "||",
  fieldIdentifierSeparator,
  wrapValueWith = ["", ""],
  translations
} = {}) => {
  const valueIsField = valueSource === "field";
  const operatorLowerCase = lc(operator);
  const quoteChar = quoteValuesWith || "'";
  const quoteValue = (v) => `${wrapValueWith[0]}${quoteChar}${v}${quoteChar}${wrapValueWith[1]}`;
  const escapeValue = (v) => escapeStringValueQuotes(v, quoteChar, escapeQuotes);
  const wrapAndEscape = (v) => quoteValue(escapeValue(v));
  const wrapFieldName = (v) => getQuotedFieldName(v, { quoteFieldNamesWith, fieldIdentifierSeparator });
  const concat = (...values) => concatOperator.toUpperCase() === "CONCAT" ? `CONCAT(${values.join(", ")})` : values.join(` ${concatOperator} `);
  switch (operatorLowerCase) {
    case "null":
    case "notnull": {
      return "";
    }
    case "in":
    case "notin": {
      const valueAsArray = toArray(value);
      if (valueAsArray.length > 0) {
        return `(${valueAsArray.map(
          (v) => valueIsField ? wrapFieldName(v) : shouldRenderAsNumber(v, parseNumbers) ? `${trimIfString(v)}` : `${wrapAndEscape(v)}`
        ).join(", ")})`;
      }
      return "";
    }
    case "between":
    case "notbetween": {
      const valueAsArray = toArray(value, { retainEmptyStrings: true });
      if (valueAsArray.length < 2 || !isValidValue(valueAsArray[0]) || !isValidValue(valueAsArray[1])) {
        return "";
      }
      const [first, second] = valueAsArray;
      const firstNum = shouldRenderAsNumber(first, parseNumbers) ? parseNumber(first, { parseNumbers: "strict" }) : Number.NaN;
      const secondNum = shouldRenderAsNumber(second, parseNumbers) ? parseNumber(second, { parseNumbers: "strict" }) : Number.NaN;
      const firstValue = Number.isNaN(firstNum) ? valueIsField ? `${first}` : first : firstNum;
      const secondValue = Number.isNaN(secondNum) ? valueIsField ? `${second}` : second : secondNum;
      const valsOneAndTwoOnly = [firstValue, secondValue];
      if (!preserveValueOrder && firstValue === firstNum && secondValue === secondNum && secondNum < firstNum) {
        valsOneAndTwoOnly[0] = secondNum;
        valsOneAndTwoOnly[1] = firstNum;
      }
      return (valueIsField ? valsOneAndTwoOnly.map((v) => wrapFieldName(v)) : valsOneAndTwoOnly.every((v) => shouldRenderAsNumber(v, parseNumbers)) ? valsOneAndTwoOnly.map((v) => parseNumber(v, { parseNumbers: "strict" })) : valsOneAndTwoOnly.map((v) => wrapAndEscape(v))).join(` ${translations?.and ?? "and"} `);
    }
    case "contains":
    case "doesnotcontain":
      return valueIsField ? concat(quoteValue("%"), wrapFieldName(value), quoteValue("%")) : quoteValue(`%${escapeValue(value)}%`);
    case "beginswith":
    case "doesnotbeginwith":
      return valueIsField ? concat(wrapFieldName(value), quoteValue("%")) : quoteValue(`${escapeValue(value)}%`);
    case "endswith":
    case "doesnotendwith":
      return valueIsField ? concat(quoteValue("%"), wrapFieldName(value)) : quoteValue(`%${escapeValue(value)}`);
  }
  if (typeof value === "boolean") {
    return value ? "TRUE" : "FALSE";
  }
  return valueIsField ? wrapFieldName(value) : shouldRenderAsNumber(value, parseNumbers) ? `${trimIfString(value)}` : `${wrapAndEscape(value)}`;
};

// src/utils/formatQuery/defaultRuleProcessorDrizzle.ts
var defaultRuleProcessorDrizzle = (rule, _options) => {
  const opts = _options ?? /* istanbul ignore next */
  {};
  const { parseNumbers, preserveValueOrder, context = {} } = opts;
  const { columns, drizzleOperators, useRawFields } = context;
  if (!columns || !drizzleOperators) return;
  const {
    between,
    eq,
    gt,
    gte,
    inArray,
    isNotNull,
    isNull,
    like,
    lt,
    lte,
    ne,
    notBetween,
    notInArray,
    notLike,
    sql
  } = drizzleOperators;
  const { field, operator, value, valueSource } = rule;
  const column = useRawFields && /[a-z][a-z0-9]*/i.test(field) ? sql.raw(field) : columns[field];
  const operatorLC = lc(operator);
  const valueIsField = valueSource === "field";
  const asFieldOrValue = (v) => valueIsField ? columns[v] : v;
  if (!column) return;
  const matchEval = processMatchMode(rule);
  if (matchEval === false) {
    return;
  } else if (matchEval) {
    if (opts.preset !== "postgresql") return;
    const { mode, threshold } = matchEval;
    const arrayElementAlias = "elem_alias";
    const sqlQuery = transformQuery(rule.value, {
      ruleProcessor: (r) => ({ ...r, field: arrayElementAlias })
    });
    const nestedArrayFilter = defaultRuleGroupProcessorDrizzle(sqlQuery, {
      ...opts,
      context: { ...opts.context, useRawFields: true }
    });
    switch (mode) {
      case "all":
        return sql`(select count(*) from unnest(${column}) as ${sql.raw(arrayElementAlias)} where ${nestedArrayFilter({}, drizzleOperators)}) = array_length(${column}, 1)`;
      case "none":
        return sql`not exists (select 1 from unnest(${column}) as ${sql.raw(arrayElementAlias)} where ${nestedArrayFilter({}, drizzleOperators)})`;
      case "some":
        return sql`exists (select 1 from unnest(${column}) as ${sql.raw(arrayElementAlias)} where ${nestedArrayFilter({}, drizzleOperators)})`;
      case "atleast":
      case "atmost":
      case "exactly": {
        const op = mode === "atleast" ? ">=" : mode === "atmost" ? "<=" : "=";
        return threshold > 0 && threshold < 1 ? sql`(select count(*) / array_length(${column}, 1) from unnest(${column}) as ${sql.raw(arrayElementAlias)} where ${nestedArrayFilter({}, drizzleOperators)}) ${sql.raw(`${op} ${threshold}`)}` : sql`(select count(*) from unnest(${column}) as ${sql.raw(arrayElementAlias)} where ${nestedArrayFilter({}, drizzleOperators)}) ${sql.raw(`${op} ${threshold}`)}`;
      }
    }
  }
  switch (operatorLC) {
    case "=":
      return eq(column, asFieldOrValue(value));
    case "!=":
      return ne(column, asFieldOrValue(value));
    case ">":
      return gt(column, asFieldOrValue(value));
    case "<":
      return lt(column, asFieldOrValue(value));
    case ">=":
      return gte(column, asFieldOrValue(value));
    case "<=":
      return lte(column, asFieldOrValue(value));
    case "beginswith":
    case "doesnotbeginwith":
      return (operatorLC === "doesnotbeginwith" ? notLike : like)(
        column,
        valueIsField ? sql`${asFieldOrValue(value)} || '%'` : `${value}%`
      );
    case "contains":
    case "doesnotcontain":
      return (operatorLC === "doesnotcontain" ? notLike : like)(
        column,
        valueIsField ? sql`'%' || ${asFieldOrValue(value)} || '%'` : `%${value}%`
      );
    case "endswith":
    case "doesnotendwith":
      return (operatorLC === "doesnotendwith" ? notLike : like)(
        column,
        valueIsField ? sql`'%' || ${asFieldOrValue(value)}` : `%${value}`
      );
    case "null":
      return isNull(column);
    case "notnull":
      return isNotNull(column);
    case "in":
    case "notin": {
      const valueAsArray = toArray(value).map((v) => asFieldOrValue(v));
      return operatorLC === "notin" ? notInArray(column, valueAsArray) : inArray(column, valueAsArray);
    }
    case "between":
    case "notbetween": {
      const valueAsArray = toArray(value);
      if (valueAsArray.length >= 2 && isValidValue(valueAsArray[0]) && isValidValue(valueAsArray[1])) {
        let [first, second] = valueAsArray;
        const shouldParseNumbers = !(parseNumbers === false);
        if (!valueIsField && shouldRenderAsNumber(first, shouldParseNumbers) && shouldRenderAsNumber(second, shouldParseNumbers)) {
          const firstNum = parseNumber(first, { parseNumbers: shouldParseNumbers });
          const secondNum = parseNumber(second, { parseNumbers: shouldParseNumbers });
          if (!preserveValueOrder && secondNum < firstNum) {
            const tempNum = secondNum;
            second = firstNum;
            first = tempNum;
          } else {
            first = firstNum;
            second = secondNum;
          }
        } else {
          if (valueIsField) {
            first = asFieldOrValue(first);
            second = asFieldOrValue(second);
          }
        }
        return operatorLC === "notbetween" ? notBetween(column, first, second) : between(column, first, second);
      }
      return;
    }
    default:
      return;
  }
};

// src/utils/formatQuery/defaultRuleGroupProcessorDrizzle.ts
var defaultRuleGroupProcessorDrizzle = (ruleGroup, options, _meta) => (columns, drizzleOperators) => {
  const {
    fields,
    getParseNumberBoolean,
    placeholderFieldName,
    placeholderOperatorName,
    placeholderValueName,
    validateRule,
    validationMap
  } = options;
  if (!columns || !drizzleOperators) return;
  const { and, not, or } = drizzleOperators;
  const query = isRuleGroupType(ruleGroup) ? ruleGroup : convertFromIC(ruleGroup);
  const ruleProcessor = defaultRuleProcessorDrizzle;
  const processRuleGroup = (rg, _outermost) => {
    if (!isRuleOrGroupValid(rg, validationMap[rg.id ?? /* istanbul ignore next */
    ""])) {
      return;
    }
    const processedRules = rg.rules.map((rule) => {
      if (isRuleGroup(rule)) {
        return processRuleGroup(rule);
      }
      const [validationResult, fieldValidator] = validateRule(rule);
      if (!isRuleOrGroupValid(rule, validationResult, fieldValidator) || rule.field === placeholderFieldName || rule.operator === placeholderOperatorName || /* istanbul ignore next */
      placeholderValueName !== void 0 && rule.value === placeholderValueName) {
        return;
      }
      const fieldData = getOption(fields, rule.field);
      return ruleProcessor(rule, {
        ...options,
        parseNumbers: getParseNumberBoolean(fieldData?.inputType),
        fieldData,
        context: { ...options.context, columns, drizzleOperators }
      });
    }).filter(Boolean);
    if (processedRules.length === 0) {
      return;
    }
    const ruleGroupSQL = rg.combinator === "or" ? or(...processedRules) : and(...processedRules);
    return rg.not ? not(ruleGroupSQL) : ruleGroupSQL;
  };
  return processRuleGroup(query, true);
};

// src/utils/formatQuery/defaultRuleGroupProcessorElasticSearch.ts
var defaultRuleGroupProcessorElasticSearch = (ruleGroup, options) => {
  const {
    fields,
    getParseNumberBoolean,
    placeholderFieldName,
    placeholderOperatorName,
    placeholderValueName,
    ruleProcessor,
    validateRule,
    validationMap
  } = options;
  const query = convertFromIC(ruleGroup);
  const processRuleGroup = (rg) => {
    if (!isRuleOrGroupValid(rg, validationMap[rg.id ?? /* istanbul ignore next */
    ""])) {
      return false;
    }
    const processedRules = rg.rules.map((rule) => {
      if (isRuleGroup(rule)) {
        return processRuleGroup(rule);
      }
      const [validationResult, fieldValidator] = validateRule(rule);
      if (!isRuleOrGroupValid(rule, validationResult, fieldValidator) || rule.field === placeholderFieldName || rule.operator === placeholderOperatorName || /* istanbul ignore next */
      placeholderValueName !== void 0 && rule.value === placeholderValueName) {
        return false;
      }
      const fieldData = getOption(fields, rule.field);
      return ruleProcessor(rule, {
        ...options,
        parseNumbers: getParseNumberBoolean(fieldData?.inputType),
        fieldData
      });
    }).filter(Boolean);
    if (processedRules.length === 0) {
      return false;
    }
    return {
      bool: rg.not ? {
        must_not: /^or$/i.test(rg.combinator) ? { bool: { should: processedRules } } : processedRules
      } : { [/^or$/i.test(rg.combinator) ? "should" : "must"]: processedRules }
    };
  };
  const processedRuleGroup = processRuleGroup(query);
  return processedRuleGroup === false ? {} : processedRuleGroup;
};

// src/utils/formatQuery/defaultRuleGroupProcessorJSONata.ts
var defaultRuleGroupProcessorJSONata = (ruleGroup, options) => {
  const {
    fields,
    fallbackExpression,
    getParseNumberBoolean,
    placeholderFieldName,
    placeholderOperatorName,
    placeholderValueName,
    ruleProcessor,
    validateRule,
    validationMap
  } = options;
  const processRuleGroup = (rg, outermost) => {
    if (!isRuleOrGroupValid(rg, validationMap[rg.id ?? /* istanbul ignore next */
    ""])) {
      return outermost ? fallbackExpression : "";
    }
    const expression = rg.rules.map((rule) => {
      if (typeof rule === "string") {
        return rule;
      }
      if (isRuleGroup(rule)) {
        return processRuleGroup(rule);
      }
      const [validationResult, fieldValidator] = validateRule(rule);
      if (!isRuleOrGroupValid(rule, validationResult, fieldValidator) || rule.field === placeholderFieldName || rule.operator === placeholderOperatorName || /* istanbul ignore next */
      placeholderValueName !== void 0 && rule.value === placeholderValueName) {
        return "";
      }
      const fieldData = getOption(fields, rule.field);
      return ruleProcessor(rule, {
        ...options,
        parseNumbers: getParseNumberBoolean(fieldData?.inputType),
        escapeQuotes: (rule.valueSource ?? "value") === "value",
        fieldData
      });
    }).filter(Boolean).join(isRuleGroupType(rg) ? ` ${rg.combinator} ` : " ");
    const [prefix, suffix] = rg.not || !outermost ? [`${rg.not ? "$not" : ""}(`, ")"] : ["", ""];
    return expression ? `${prefix}${expression}${suffix}` : fallbackExpression;
  };
  return processRuleGroup(ruleGroup, true);
};

// src/utils/formatQuery/defaultRuleGroupProcessorJsonLogic.ts
var defaultRuleGroupProcessorJsonLogic = (ruleGroup, options) => {
  const {
    fields,
    getParseNumberBoolean,
    placeholderFieldName,
    placeholderOperatorName,
    placeholderValueName,
    ruleProcessor,
    validateRule,
    validationMap
  } = options;
  const query = convertFromIC(ruleGroup);
  const processRuleGroup = (rg, _outermost) => {
    if (!isRuleOrGroupValid(rg, validationMap[rg.id ?? /* istanbul ignore next */
    ""])) {
      return false;
    }
    const processedRules = rg.rules.map((rule) => {
      if (isRuleGroup(rule)) {
        return processRuleGroup(rule);
      }
      const [validationResult, fieldValidator] = validateRule(rule);
      if (!isRuleOrGroupValid(rule, validationResult, fieldValidator) || rule.field === placeholderFieldName || rule.operator === placeholderOperatorName || /* istanbul ignore next */
      placeholderValueName !== void 0 && rule.value === placeholderValueName) {
        return false;
      }
      const fieldData = getOption(fields, rule.field);
      return ruleProcessor(rule, {
        ...options,
        parseNumbers: getParseNumberBoolean(fieldData?.inputType),
        fieldData
      });
    }).filter(Boolean);
    if (processedRules.length === 0) {
      return false;
    }
    const jsonRuleGroup = { [rg.combinator]: processedRules };
    return rg.not ? { "!": jsonRuleGroup } : jsonRuleGroup;
  };
  return processRuleGroup(query, true);
};

// src/utils/formatQuery/defaultRuleGroupProcessorLDAP.ts
var defaultRuleGroupProcessorLDAP = (ruleGroup, options) => {
  const {
    fields,
    fallbackExpression,
    getParseNumberBoolean,
    placeholderFieldName,
    placeholderOperatorName,
    placeholderValueName,
    ruleProcessor,
    validateRule,
    validationMap
  } = options;
  const query = convertFromIC(ruleGroup);
  const processRuleGroup = (rg, outermost) => {
    if (!isRuleOrGroupValid(rg, validationMap[rg.id ?? /* istanbul ignore next */
    ""])) {
      return outermost ? fallbackExpression : "";
    }
    const rules = rg.rules.map((rule) => {
      if (isRuleGroup(rule)) {
        return processRuleGroup(rule);
      }
      const [validationResult, fieldValidator] = validateRule(rule);
      if (!isRuleOrGroupValid(rule, validationResult, fieldValidator) || rule.field === placeholderFieldName || rule.operator === placeholderOperatorName || /* istanbul ignore next */
      placeholderValueName !== void 0 && rule.value === placeholderValueName) {
        return "";
      }
      const fieldData = getOption(fields, rule.field);
      return ruleProcessor(rule, {
        ...options,
        parseNumbers: getParseNumberBoolean(fieldData?.inputType),
        escapeQuotes: (rule.valueSource ?? "value") === "value",
        fieldData
      });
    }).filter(Boolean);
    const expression = rules.join("");
    const [notPrefix, notSuffix] = rg.not ? ["(!", ")"] : ["", ""];
    const [prefix, suffix] = rules.length > 1 ? [`${notPrefix}(${rg.combinator === "or" ? "|" : "&"}`, `)${notSuffix}`] : [notPrefix, notSuffix];
    return expression ? `${prefix}${expression}${suffix}` : fallbackExpression;
  };
  return processRuleGroup(query, true);
};

// src/utils/formatQuery/defaultRuleGroupProcessorMongoDB.ts
var isBracketed = (str) => str.startsWith("{") && str.endsWith("}");
var defaultRuleGroupProcessorMongoDB = (ruleGroup, options, meta) => {
  const {
    fields,
    fallbackExpression,
    getParseNumberBoolean,
    placeholderFieldName,
    placeholderOperatorName,
    placeholderValueName,
    ruleProcessor,
    validateRule,
    validationMap
  } = options;
  const processRuleGroup = (rg, outermost) => {
    if (!isRuleOrGroupValid(rg, validationMap[rg.id ?? /* istanbul ignore next */
    ""])) {
      return outermost ? fallbackExpression : "";
    }
    const combinator = `"$${lc(rg.combinator)}"`;
    let hasChildRules = false;
    const expressions = rg.rules.map((rule) => {
      if (isRuleGroup(rule)) {
        const processedRuleGroup = processRuleGroup(rule);
        if (processedRuleGroup) {
          hasChildRules = true;
          return isBracketed(processedRuleGroup) ? processedRuleGroup : `{${processedRuleGroup}}`;
        }
        return "";
      }
      const [validationResult, fieldValidator] = validateRule(rule);
      if (!isRuleOrGroupValid(rule, validationResult, fieldValidator) || rule.field === placeholderFieldName || rule.operator === placeholderOperatorName || /* istanbul ignore next */
      placeholderValueName !== void 0 && rule.value === placeholderValueName) {
        return "";
      }
      const fieldData = getOption(fields, rule.field);
      return ruleProcessor(
        rule,
        {
          ...options,
          parseNumbers: getParseNumberBoolean(fieldData?.inputType),
          fieldData
        },
        meta
      );
    }).filter(Boolean);
    return expressions.length > 0 ? expressions.length === 1 && !hasChildRules ? expressions[0] : `${combinator}:[${expressions.join(",")}]` : fallbackExpression;
  };
  const processedQuery = processRuleGroup(convertFromIC(ruleGroup), true);
  return isBracketed(processedQuery) ? processedQuery : `{${processedQuery}}`;
};

// src/utils/formatQuery/defaultRuleGroupProcessorNL.ts
var defaultRuleGroupProcessorNL = (ruleGroup, options) => {
  const {
    fields,
    fallbackExpression,
    getParseNumberBoolean,
    placeholderFieldName,
    placeholderOperatorName,
    placeholderValueName,
    ruleProcessor,
    translations,
    validateRule,
    validationMap
  } = options;
  const processRuleGroup = (rg, outermostOrLonelyInGroup) => {
    if (!isRuleOrGroupValid(rg, validationMap[rg.id ?? /* istanbul ignore next */
    ""])) {
      return outermostOrLonelyInGroup ? fallbackExpression : (
        /* istanbul ignore next */
        ""
      );
    }
    const rg2 = isRuleGroupTypeIC(rg) && rg.rules.some((r) => typeof r === "string" && lc(r) === "xor") ? convertFromIC(rg) : rg;
    const processedRules = rg2.rules.map((rule) => {
      if (typeof rule === "string") {
        return `, ${translations[rule] ?? rule} `;
      }
      if (isRuleGroup(rule)) {
        return processRuleGroup(
          rule,
          rg2.rules.length === 1 && !(rg2.not || /^xor$/i.test(rg2.combinator ?? /* istanbul ignore next */
          ""))
        );
      }
      const [validationResult, fieldValidator] = validateRule(rule);
      if (!isRuleOrGroupValid(rule, validationResult, fieldValidator) || rule.field === placeholderFieldName || rule.operator === placeholderOperatorName || /* istanbul ignore next */
      placeholderValueName !== void 0 && rule.value === placeholderValueName) {
        return "";
      }
      const escapeQuotes = (rule.valueSource ?? "value") === "value";
      const fieldData = getOption(fields, rule.field);
      return ruleProcessor(rule, {
        ...options,
        parseNumbers: getParseNumberBoolean(fieldData?.inputType),
        escapeQuotes,
        fieldData
      });
    });
    if (processedRules.length === 0) {
      return fallbackExpression;
    }
    const isXOR = lc(rg2.combinator ?? "") === "xor";
    const combinator = isXOR ? rg2.combinator.slice(1) : rg2.combinator;
    const mustWrap = rg2.not || !outermostOrLonelyInGroup || isXOR && processedRules.length > 1;
    const [prefixTL, suffixTL] = ["groupPrefix", "groupSuffix"].map(
      (key) => rg2.not ? isXOR ? getNLTranslataion(key, translations, ["not", "xor"]) : getNLTranslataion(key, translations, ["not"]) : isXOR ? getNLTranslataion(key, translations, ["xor"]) : getNLTranslataion(key, translations)
    );
    const prefix = mustWrap ? `${prefixTL} (`.trim() : "";
    const suffix = mustWrap ? `) ${suffixTL}`.trim() : "";
    return `${prefix}${processedRules.filter(Boolean).join(
      isRuleGroupType(rg2) ? `, ${translations[combinator] ?? combinator} ` : ""
    )}${suffix}`;
  };
  return processRuleGroup(ruleGroup, true);
};

// src/utils/formatQuery/defaultRuleGroupProcessorParameterized.ts
var defaultRuleGroupProcessorParameterized = (ruleGroup, options) => {
  const {
    format,
    fields,
    fallbackExpression,
    getParseNumberBoolean,
    placeholderFieldName,
    placeholderOperatorName,
    placeholderValueName,
    ruleProcessor,
    validateRule,
    validationMap
  } = options;
  const parameterized = format === "parameterized";
  const params = [];
  const paramsNamed = {};
  const fieldParams = /* @__PURE__ */ new Map();
  const getNextNamedParam = (field) => {
    if (!fieldParams.has(field)) {
      fieldParams.set(field, /* @__PURE__ */ new Set());
    }
    const nextNamedParam = `${field}_${fieldParams.get(field).size + 1}`;
    fieldParams.get(field).add(nextNamedParam);
    return nextNamedParam;
  };
  const processRule = (rule) => {
    const [validationResult, fieldValidator] = validateRule(rule);
    if (!isRuleOrGroupValid(rule, validationResult, fieldValidator) || rule.field === placeholderFieldName || rule.operator === placeholderOperatorName || /* istanbul ignore next */
    placeholderValueName !== void 0 && rule.value === placeholderValueName) {
      return "";
    }
    const fieldData = getOption(fields, rule.field);
    const fieldParamNames = Object.fromEntries(
      [...fieldParams.entries()].map(([f, s]) => [f, [...s]])
    );
    const processedRule = ruleProcessor(
      rule,
      {
        ...options,
        parseNumbers: getParseNumberBoolean(fieldData?.inputType),
        getNextNamedParam,
        fieldParamNames,
        fieldData
      },
      { processedParams: params }
    );
    if (!isPojo(processedRule)) {
      return "";
    }
    const { sql, params: customParams } = processedRule;
    if (typeof sql !== "string" || !sql) {
      return "";
    }
    if (format === "parameterized" && Array.isArray(customParams)) {
      params.push(...customParams);
    } else if (format === "parameterized_named" && isPojo(customParams)) {
      Object.assign(paramsNamed, customParams);
      for (const p of Object.keys(customParams)) fieldParams.get(rule.field)?.add(p);
    }
    return sql;
  };
  const processRuleGroup = (rg, outermostOrLonelyInGroup) => {
    if (!isRuleOrGroupValid(rg, validationMap[rg.id ?? /* istanbul ignore next */
    ""])) {
      return outermostOrLonelyInGroup ? fallbackExpression : (
        /* istanbul ignore next */
        ""
      );
    }
    const processedRules = rg.rules.map((rule) => {
      if (typeof rule === "string") {
        return rule;
      }
      if (isRuleGroup(rule)) {
        return processRuleGroup(rule, rg.rules.length === 1);
      }
      return processRule(rule);
    }).filter(Boolean);
    if (processedRules.length === 0) {
      return fallbackExpression;
    }
    return `${rg.not ? "NOT " : ""}(${processedRules.join(isRuleGroupType(rg) ? ` ${rg.combinator} ` : " ")})`;
  };
  if (parameterized) {
    return { sql: processRuleGroup(ruleGroup, true), params };
  }
  return { sql: processRuleGroup(ruleGroup, true), params: paramsNamed };
};

// src/utils/formatQuery/defaultRuleGroupProcessorPrisma.ts
var prismaFallback = {};
var defaultRuleGroupProcessorPrisma = (ruleGroup, options) => {
  const {
    fields,
    getParseNumberBoolean,
    placeholderFieldName,
    placeholderOperatorName,
    placeholderValueName,
    ruleProcessor,
    validateRule,
    validationMap
  } = options;
  const processRuleGroup = (rg, outermost) => {
    if (!isRuleOrGroupValid(rg, validationMap[rg.id ?? /* istanbul ignore next */
    ""])) {
      return outermost ? prismaFallback : void 0;
    }
    const combinator = rg.combinator.toUpperCase();
    let hasChildRules = false;
    const expressions = rg.rules.map((rule) => {
      if (isRuleGroup(rule)) {
        const processedRuleGroup = processRuleGroup(rule);
        if (processedRuleGroup) {
          hasChildRules = true;
          return processedRuleGroup;
        }
        return;
      }
      const [validationResult, fieldValidator] = validateRule(rule);
      if (!isRuleOrGroupValid(rule, validationResult, fieldValidator) || rule.field === placeholderFieldName || rule.operator === placeholderOperatorName || /* istanbul ignore next */
      placeholderValueName !== void 0 && rule.value === placeholderValueName) {
        return;
      }
      const fieldData = getOption(fields, rule.field);
      return ruleProcessor(rule, {
        ...options,
        parseNumbers: getParseNumberBoolean(fieldData?.inputType),
        fieldData
      });
    }).filter(Boolean);
    return expressions.length > 0 ? expressions.length === 1 && !hasChildRules ? expressions[0] : { [combinator]: expressions } : prismaFallback;
  };
  const result = processRuleGroup(convertFromIC(ruleGroup), true);
  return ruleGroup.not ? { NOT: result } : result;
};

// src/utils/formatQuery/defaultRuleGroupProcessorSequelize.ts
var defaultRuleGroupProcessorSequelize = (ruleGroup, options) => {
  const {
    fields,
    getParseNumberBoolean,
    placeholderFieldName,
    placeholderOperatorName,
    placeholderValueName,
    ruleProcessor,
    validateRule,
    validationMap,
    context = {}
  } = options;
  const { sequelizeOperators: Op } = context;
  if (!Op) return;
  const processRuleGroup = (rg, _outermost) => {
    if (!isRuleOrGroupValid(rg, validationMap[rg.id ?? /* istanbul ignore next */
    ""])) {
      return;
    }
    const combinator = rg.combinator.toUpperCase();
    let hasChildRules = false;
    const expressions = rg.rules.map((rule) => {
      if (isRuleGroup(rule)) {
        const processedRuleGroup = processRuleGroup(rule);
        if (processedRuleGroup) {
          hasChildRules = true;
          return processedRuleGroup;
        }
        return;
      }
      const [validationResult, fieldValidator] = validateRule(rule);
      if (!isRuleOrGroupValid(rule, validationResult, fieldValidator) || rule.field === placeholderFieldName || rule.operator === placeholderOperatorName || /* istanbul ignore next */
      placeholderValueName !== void 0 && rule.value === placeholderValueName) {
        return;
      }
      const fieldData = getOption(fields, rule.field);
      return ruleProcessor(rule, {
        ...options,
        parseNumbers: getParseNumberBoolean(fieldData?.inputType),
        fieldData
      });
    }).filter(Boolean);
    if (expressions.length === 0) return;
    const result = expressions.length === 1 && !hasChildRules ? expressions[0] : { [lc(combinator) === "or" ? Op.or : Op.and]: expressions };
    return rg.not ? { [Op.not]: result } : result;
  };
  return processRuleGroup(convertFromIC(ruleGroup), true);
};

// src/utils/formatQuery/defaultRuleGroupProcessorSQL.ts
var defaultRuleGroupProcessorSQL = (ruleGroup, options) => {
  const {
    fields,
    fallbackExpression,
    getParseNumberBoolean,
    placeholderFieldName,
    placeholderOperatorName,
    placeholderValueName,
    ruleProcessor,
    validateRule,
    validationMap
  } = options;
  const processRuleGroup = (rg, outermostOrLonelyInGroup) => {
    if (!isRuleOrGroupValid(rg, validationMap[rg.id ?? /* istanbul ignore next */
    ""])) {
      return outermostOrLonelyInGroup ? fallbackExpression : (
        /* istanbul ignore next */
        ""
      );
    }
    const processedRules = rg.rules.map((rule) => {
      if (typeof rule === "string") {
        return rule;
      }
      if (isRuleGroup(rule)) {
        return processRuleGroup(rule, rg.rules.length === 1);
      }
      const [validationResult, fieldValidator] = validateRule(rule);
      if (!isRuleOrGroupValid(rule, validationResult, fieldValidator) || rule.field === placeholderFieldName || rule.operator === placeholderOperatorName || placeholderValueName !== void 0 && rule.value === placeholderValueName) {
        return "";
      }
      const escapeQuotes = (rule.valueSource ?? "value") === "value";
      const fieldData = getOption(fields, rule.field);
      return ruleProcessor(rule, {
        ...options,
        parseNumbers: getParseNumberBoolean(fieldData?.inputType),
        escapeQuotes,
        fieldData
      });
    }).filter(Boolean);
    if (processedRules.length === 0) {
      return fallbackExpression;
    }
    return `${rg.not ? "NOT " : ""}(${processedRules.join(isRuleGroupType(rg) ? ` ${rg.combinator} ` : " ")})`;
  };
  return processRuleGroup(ruleGroup, true);
};

// src/utils/formatQuery/defaultRuleProcessorElasticSearch.ts
var rangeOperatorMap = { "<": "lt", "<=": "lte", ">": "gt", ">=": "gte" };
var negateIfNotOp = (op, elasticSearchRule) => op.startsWith("not") || op.startsWith("doesnot") ? { bool: { must_not: elasticSearchRule } } : elasticSearchRule;
var escapeSQ = (s) => s?.replace(/('|\\)/g, `\\$1`);
var textFunctionMap = {
  beginswith: "startsWith",
  doesnotbeginwith: "startsWith",
  doesnotcontain: "contains",
  doesnotendwith: "endsWith",
  endswith: "endsWith"
};
var getTextScript = (f, o, v) => {
  const script = `doc['${f}'].value.${textFunctionMap[o] ?? o}(doc['${v}'].value)`;
  return o.startsWith("d") ? `!${script}` : script;
};
var valueRenderer = (v, parseNumbers) => typeof v === "boolean" ? v : shouldRenderAsNumber(v, parseNumbers) ? parseNumber(v, { parseNumbers }) : v;
var defaultRuleProcessorElasticSearch = (rule, options = {}) => {
  const { field, operator, value, valueSource } = rule;
  const { parseNumbers, preserveValueOrder } = options;
  const operatorLC = lc(operator);
  if (processMatchMode(rule)) return false;
  if (valueSource === "field") {
    if (toArray(value).some((v) => typeof v !== "string")) return false;
    const fieldForScript = escapeSQ(field);
    switch (operatorLC) {
      case "=":
      case "!=":
      case ">":
      case ">=":
      case "<":
      case "<=": {
        const operatorForScript = operatorLC === "=" ? "==" : operatorLC;
        const valueForScript = escapeSQ(value);
        return valueForScript ? {
          bool: {
            filter: {
              script: {
                script: `doc['${fieldForScript}'].value ${operatorForScript} doc['${valueForScript}'].value`
              }
            }
          }
        } : false;
      }
      case "in":
      case "notin": {
        const valueAsArray = toArray(value);
        if (valueAsArray.length > 0) {
          const arr = valueAsArray.map((v) => ({
            bool: {
              filter: { script: { script: `doc['${fieldForScript}'].value == doc['${v}'].value` } }
            }
          }));
          return { bool: operatorLC === "in" ? { should: arr } : { must_not: arr } };
        }
        return false;
      }
      case "between":
      case "notbetween": {
        const valueAsArray = toArray(value);
        if (valueAsArray.length >= 2 && valueAsArray[0] && valueAsArray[1]) {
          const script = `doc['${fieldForScript}'].value >= doc['${valueAsArray[0]}'].value && doc['${fieldForScript}'].value <= doc['${valueAsArray[1]}'].value`;
          return {
            bool: {
              filter: { script: { script: operatorLC === "notbetween" ? `!(${script})` : script } }
            }
          };
        }
        return false;
      }
      case "contains":
      case "doesnotcontain":
      case "beginswith":
      case "doesnotbeginwith":
      case "endswith":
      case "doesnotendwith": {
        const valueForScript = escapeSQ(value);
        if (!valueForScript) return false;
        const script = getTextScript(fieldForScript, operatorLC, valueForScript);
        return {
          bool: {
            filter: {
              script: {
                script
              }
            }
          }
        };
      }
    }
  }
  switch (operatorLC) {
    case "<":
    case "<=":
    case ">":
    case ">=":
      return {
        range: {
          [field]: {
            [rangeOperatorMap[operatorLC]]: valueRenderer(value, parseNumbers)
          }
        }
      };
    case "=":
      return { term: { [field]: valueRenderer(value, parseNumbers) } };
    case "!=":
      return { bool: { must_not: { term: { [field]: valueRenderer(value, parseNumbers) } } } };
    case "null":
      return { bool: { must_not: { exists: { field } } } };
    case "notnull":
      return { exists: { field } };
    case "in":
    case "notin": {
      const valueAsArray = toArray(value).map((v) => valueRenderer(v, parseNumbers));
      if (valueAsArray.length > 0) {
        const arr = valueAsArray.map((v) => ({ term: { [field]: valueRenderer(v, parseNumbers) } }));
        return { bool: operatorLC === "in" ? { should: arr } : { must_not: arr } };
      }
      return false;
    }
    case "between":
    case "notbetween": {
      const valueAsArray = toArray(value);
      if (valueAsArray.length >= 2 && isValidValue(valueAsArray[0]) && isValidValue(valueAsArray[1])) {
        let [first, second] = valueAsArray;
        const shouldParseNumbers = !(parseNumbers === false);
        if (shouldRenderAsNumber(first, shouldParseNumbers) && shouldRenderAsNumber(second, shouldParseNumbers)) {
          const firstNum = parseNumber(first, { parseNumbers: shouldParseNumbers });
          const secondNum = parseNumber(second, { parseNumbers: shouldParseNumbers });
          if (!preserveValueOrder && secondNum < firstNum) {
            const tempNum = secondNum;
            second = firstNum;
            first = tempNum;
          } else {
            first = firstNum;
            second = secondNum;
          }
        }
        return negateIfNotOp(operatorLC, { range: { [field]: { gte: first, lte: second } } });
      }
      return false;
    }
    case "contains":
    case "doesnotcontain":
      return negateIfNotOp(operatorLC, { regexp: { [field]: { value: `.*${value}.*` } } });
    case "beginswith":
    case "doesnotbeginwith":
      return negateIfNotOp(operatorLC, { regexp: { [field]: { value: `${value}.*` } } });
    case "endswith":
    case "doesnotendwith":
      return negateIfNotOp(operatorLC, { regexp: { [field]: { value: `.*${value}` } } });
  }
  return false;
};

// src/utils/formatQuery/defaultRuleProcessorJSONata.ts
var shouldNegate3 = (op) => op.startsWith("not") || op.startsWith("doesnot");
var quote = (v, escapeQuotes) => `"${typeof v !== "string" || !escapeQuotes ? v : v.replaceAll(`"`, `\\"`)}"`;
var negate = (clause, negate2) => negate2 ? `$not(${clause})` : `${clause}`;
var escapeStringRegex = (s) => `${s}`.replaceAll(/[/$()*+.?[\\\]^{|}]/g, String.raw`\$&`).replaceAll("-", String.raw`\x2d`);
var defaultRuleProcessorJSONata = (rule, options = {}) => {
  const { field, operator, value, valueSource } = rule;
  const {
    escapeQuotes,
    parseNumbers,
    preserveValueOrder,
    quoteFieldNamesWith = ["", ""],
    fieldIdentifierSeparator = ""
  } = options;
  const valueIsField = valueSource === "field";
  const useBareValue = typeof value === "number" || typeof value === "boolean" || typeof value === "bigint" || shouldRenderAsNumber(value, parseNumbers);
  const qfn = (f) => getQuotedFieldName(f, { quoteFieldNamesWith, fieldIdentifierSeparator });
  const matchEval = processMatchMode(rule);
  if (matchEval === false) {
    return;
  } else if (matchEval) {
    const { mode, threshold } = matchEval;
    const totalCount = `$count(${qfn(field)})`;
    const filteredCount = `$count($filter(${qfn(field)}, function($v) {${defaultRuleGroupProcessorJSONata(
      transformQuery(value, {
        ruleProcessor: (r) => ({ ...r, field: r.field ? `$v.${r.field}` : "$v" })
      }),
      options
    )}}))`;
    switch (mode) {
      case "all":
        return `${filteredCount} = ${totalCount}`;
      case "none":
        return `${filteredCount} = 0`;
      case "some":
        return `${filteredCount} > 0`;
      case "atleast":
      case "atmost":
      case "exactly": {
        const op = mode === "atleast" ? ">=" : mode === "atmost" ? "<=" : "=";
        if (threshold > 0 && threshold < 1) {
          return `${filteredCount} ${op} (${totalCount} * ${threshold})`;
        }
        return `${filteredCount} ${op} ${threshold}`;
      }
    }
  }
  const operatorLC = lc(operator);
  switch (operatorLC) {
    case "<":
    case "<=":
    case "=":
    case "!=":
    case ">":
    case ">=":
      return `${qfn(field)} ${operatorLC} ${valueIsField ? qfn(trimIfString(value)) : useBareValue ? trimIfString(value) : quote(value, escapeQuotes)}`;
    case "contains":
    case "doesnotcontain":
      return negate(
        `$contains(${qfn(field)}, ${valueIsField ? qfn(trimIfString(value)) : quote(value, escapeQuotes)})`,
        shouldNegate3(operatorLC)
      );
    case "beginswith":
    case "doesnotbeginwith":
      return negate(
        valueIsField ? `$substring(${qfn(field)}, 0, $length(${qfn(trimIfString(value))})) = ${qfn(trimIfString(value))}` : `$contains(${qfn(field)}, /^${escapeStringRegex(value)}/)`,
        shouldNegate3(operatorLC)
      );
    case "endswith":
    case "doesnotendwith":
      return negate(
        valueIsField ? `$substring(${qfn(field)}, $length(${qfn(field)}) - $length(${qfn(trimIfString(value))})) = ${qfn(trimIfString(value))}` : `$contains(${qfn(field)}, /${escapeStringRegex(value)}$/)`,
        shouldNegate3(operatorLC)
      );
    case "null":
      return `${qfn(field)} = null`;
    case "notnull":
      return `${qfn(field)} != null`;
    case "in":
    case "notin": {
      const valueAsArray = toArray(value);
      return negate(
        `${qfn(field)} in [${valueAsArray.map(
          (val) => valueIsField ? `${qfn(trimIfString(val))}` : shouldRenderAsNumber(val, parseNumbers) ? `${trimIfString(val)}` : quote(val, escapeQuotes)
        ).join(", ")}]`,
        shouldNegate3(operatorLC)
      );
    }
    case "between":
    case "notbetween": {
      const valueAsArray = toArray(value);
      if (valueAsArray.length < 2 || nullOrUndefinedOrEmpty(valueAsArray[0]) || nullOrUndefinedOrEmpty(valueAsArray[1])) {
        return "";
      }
      const [first, second] = valueAsArray;
      const shouldParseNumbers = !(parseNumbers === false);
      const firstNum = shouldRenderAsNumber(first, shouldParseNumbers) ? parseNumber(first, { parseNumbers: shouldParseNumbers }) : Number.NaN;
      const secondNum = shouldRenderAsNumber(second, shouldParseNumbers) ? parseNumber(second, { parseNumbers: shouldParseNumbers }) : Number.NaN;
      let firstValue = Number.isNaN(firstNum) ? valueIsField ? `${first}` : first : firstNum;
      let secondValue = Number.isNaN(secondNum) ? valueIsField ? `${second}` : second : secondNum;
      if (!preserveValueOrder && firstValue === firstNum && secondValue === secondNum && secondNum < firstNum) {
        const tempNum = secondNum;
        secondValue = firstNum;
        firstValue = tempNum;
      }
      const renderAsNumbers = shouldRenderAsNumber(first, parseNumbers) && shouldRenderAsNumber(second, parseNumbers);
      const getValueString = (raw, val) => valueIsField ? qfn(raw) : renderAsNumbers ? val : quote(val, escapeQuotes);
      const expression = `${qfn(field)} >= ${getValueString(first, firstValue)} and ${qfn(field)} <= ${getValueString(second, secondValue)}`;
      return operatorLC === "between" ? `(${expression})` : negate(expression, true);
    }
  }
  return "";
};

// src/utils/formatQuery/defaultRuleProcessorJsonLogic.ts
var convertOperator = (op) => op.replace(/^(=)$/, "$1=").replace(/^notnull$/i, "!=").replace(/^null$/i, "==");
var negateIfNotOp2 = (op, jsonRule) => op.startsWith("not") || op.startsWith("doesnot") ? { "!": jsonRule } : jsonRule;
var defaultRuleProcessorJsonLogic = (rule, options = {}) => {
  const { field, operator, value, valueSource } = rule;
  const { parseNumbers, preserveValueOrder } = options;
  const valueIsField = valueSource === "field";
  const fieldObject = { var: field };
  const fieldOrNumberRenderer = (v) => valueIsField ? { var: `${v}` } : shouldRenderAsNumber(v, parseNumbers) ? parseNumber(v, { parseNumbers }) : v;
  const matchEval = processMatchMode(rule);
  if (matchEval === false) {
    return false;
  } else if (matchEval) {
    const { mode, threshold } = matchEval;
    switch (mode) {
      case "all":
      case "none":
      case "some":
        return {
          [mode]: [
            { var: field },
            value.rules.length === 1 && !isRuleGroup(value.rules[0]) ? defaultRuleProcessorJsonLogic(value.rules[0], options) : defaultRuleGroupProcessorJsonLogic(value, options)
          ]
        };
      case "atleast":
      case "atmost":
      case "exactly": {
        const op = mode === "atleast" ? ">=" : mode === "atmost" ? "<=" : "==";
        const filteredCount = {
          reduce: [
            {
              filter: [
                { var: field },
                value.rules.length === 1 && !isRuleGroup(value.rules[0]) ? defaultRuleProcessorJsonLogic(value.rules[0], options) : defaultRuleGroupProcessorJsonLogic(value, options)
              ]
            },
            { "+": [1, { var: "accumulator" }] },
            0
          ]
        };
        if (threshold > 0 && threshold < 1) {
          const totalCount = {
            reduce: [{ var: field }, { "+": [1, { var: "accumulator" }] }, 0]
          };
          return { [op]: [filteredCount, { "*": [totalCount, threshold] }] };
        }
        return { [op]: [filteredCount, threshold] };
      }
    }
  }
  const operatorLC = lc(operator);
  switch (operatorLC) {
    case "<":
    case "<=":
    case "=":
    case "!=":
    case ">":
    case ">=":
      return {
        [convertOperator(operatorLC)]: [fieldObject, fieldOrNumberRenderer(value)]
      };
    case "null":
    case "notnull": {
      return {
        [`${operatorLC === "notnull" ? "!" : "="}=`]: [fieldObject, null]
      };
    }
    case "in":
    case "notin": {
      const valueAsArray = toArray(value).map((v) => fieldOrNumberRenderer(v));
      return negateIfNotOp2(operatorLC, { in: [fieldObject, valueAsArray] });
    }
    case "between":
    case "notbetween": {
      const valueAsArray = toArray(value);
      if (valueAsArray.length >= 2 && isValidValue(valueAsArray[0]) && isValidValue(valueAsArray[1])) {
        let [first, second] = valueAsArray;
        const shouldParseNumbers = !(parseNumbers === false);
        if (!valueIsField && shouldRenderAsNumber(first, shouldParseNumbers) && shouldRenderAsNumber(second, shouldParseNumbers)) {
          const firstNum = parseNumber(first, { parseNumbers: shouldParseNumbers });
          const secondNum = parseNumber(second, { parseNumbers: shouldParseNumbers });
          if (!preserveValueOrder && secondNum < firstNum) {
            const tempNum = secondNum;
            second = firstNum;
            first = tempNum;
          } else {
            first = firstNum;
            second = secondNum;
          }
        } else if (valueIsField) {
          first = { var: first };
          second = { var: second };
        }
        const jsonRule = { "<=": [first, fieldObject, second] };
        return negateIfNotOp2(operatorLC, jsonRule);
      }
      return false;
    }
    case "contains":
    case "doesnotcontain": {
      const jsonRule = {
        in: [fieldOrNumberRenderer(value), fieldObject]
      };
      return negateIfNotOp2(operatorLC, jsonRule);
    }
    case "beginswith":
    case "doesnotbeginwith": {
      const jsonRule = {
        startsWith: [fieldObject, fieldOrNumberRenderer(value)]
      };
      return negateIfNotOp2(operatorLC, jsonRule);
    }
    case "endswith":
    case "doesnotendwith": {
      const jsonRule = {
        endsWith: [fieldObject, fieldOrNumberRenderer(value)]
      };
      return negateIfNotOp2(operatorLC, jsonRule);
    }
  }
  return false;
};

// src/utils/formatQuery/defaultRuleProcessorLDAP.ts
var negateIf = (clause, negate2) => negate2 ? `(!${clause})` : `${clause}`;
var ldapEscape = (s) => `${trimIfString(s)}`.replaceAll(
  /[()&|=<>~*\\/]/g,
  (m) => `\\${m.codePointAt(0).toString(16)}`
);
var defaultRuleProcessorLDAP = (rule, options = {}) => {
  const { field, operator, value, valueSource } = rule;
  const { preserveValueOrder } = options;
  const operatorLC = lc(operator);
  if (
    // This is a field comparison (which LDAP does not support), or
    valueSource === "field" || // `value` is null/undefined/empty and the operator is not unary, or
    nullOrUndefinedOrEmpty(value) && operatorLC !== "null" && operatorLC !== "notnull" || // a valid `match` property is found (match modes are not supported in this format)
    processMatchMode(rule)
  ) {
    return "";
  }
  switch (operatorLC) {
    case "=":
    case "!=":
      return negateIf(`(${field}=${ldapEscape(value)})`, operatorLC === "!=");
    case ">":
    case ">=":
      return `(${field}>=${ldapEscape(value)})`;
    case "<":
    case "<=":
      return `(${field}<=${ldapEscape(value)})`;
    case "contains":
    case "doesnotcontain":
      return negateIf(`(${field}=*${ldapEscape(value)}*)`, operatorLC === "doesnotcontain");
    case "beginswith":
    case "doesnotbeginwith":
      return negateIf(`(${field}=${ldapEscape(value)}*)`, operatorLC === "doesnotbeginwith");
    case "endswith":
    case "doesnotendwith":
      return negateIf(`(${field}=*${ldapEscape(value)})`, operatorLC === "doesnotendwith");
    case "null":
    case "notnull":
      return negateIf(`(${field}=*)`, operatorLC === "notnull");
    case "in":
    case "notin": {
      const valueAsArray = toArray(value);
      return negateIf(
        `(|${valueAsArray.map((val) => `(${field}=${ldapEscape(val)})`).join("")})`,
        operatorLC === "notin"
      );
    }
    case "between":
    case "notbetween": {
      const valueAsArray = toArray(value);
      if (valueAsArray.length < 2 || nullOrUndefinedOrEmpty(valueAsArray[0]) || nullOrUndefinedOrEmpty(valueAsArray[1])) {
        return "";
      }
      const [first, second] = valueAsArray;
      const firstNum = shouldRenderAsNumber(first, true) ? parseNumber(first, { parseNumbers: true }) : Number.NaN;
      const secondNum = shouldRenderAsNumber(second, true) ? parseNumber(second, { parseNumbers: true }) : Number.NaN;
      let firstValue = Number.isNaN(firstNum) ? first : firstNum;
      let secondValue = Number.isNaN(secondNum) ? second : secondNum;
      if (!preserveValueOrder && firstValue === firstNum && secondValue === secondNum && secondNum < firstNum) {
        const tempNum = secondNum;
        secondValue = firstNum;
        firstValue = tempNum;
      }
      return negateIf(
        `(&(${field}>=${ldapEscape(firstValue)})(${field}<=${ldapEscape(secondValue)}))`,
        operatorLC === "notbetween"
      );
    }
  }
  return "";
};

// src/utils/formatQuery/defaultValueProcessorNL.ts
var escapeStringValueQuotes2 = (v, quoteChar, escapeQuotes) => escapeQuotes && typeof v === "string" ? v.replaceAll(`${quoteChar}`, `${quoteChar}${quoteChar}`) : (
  /* istanbul ignore next */
  v
);
var defaultValueProcessorNL = (rule, opts = {}) => {
  const {
    escapeQuotes,
    fields,
    parseNumbers,
    quoteFieldNamesWith,
    quoteValuesWith,
    fieldIdentifierSeparator,
    translations
  } = opts;
  const valueIsField = rule.valueSource === "field";
  const operatorLowerCase = lc(rule.operator);
  const quoteChar = quoteValuesWith || /* istanbul ignore next */
  "'";
  const quoteValue = (v) => `${quoteChar}${v}${quoteChar}`;
  const escapeValue = (v) => escapeStringValueQuotes2(v, quoteChar, escapeQuotes);
  const wrapAndEscape = (v) => quoteValue(escapeValue(v));
  const wrapFieldName = (v) => getQuotedFieldName(v, { quoteFieldNamesWith, fieldIdentifierSeparator });
  const t = translations ?? /* istanbul ignore next */
  {};
  const orTL = t.or ?? "or";
  const trueTL = t.true ?? "true";
  const falseTL = t.false ?? "false";
  switch (operatorLowerCase) {
    case "null":
    case "notnull": {
      return "";
    }
    case "between":
    case "notbetween": {
      if (!valueIsField) {
        return defaultValueProcessorByRule(rule, opts);
      }
      const valueAsArray = toArray(rule.value, { retainEmptyStrings: true }).slice(0, 2).map(
        (v) => wrapFieldName(
          getOption(fields ?? /* istanbul ignore next */
          [], v)?.label ?? v
        )
      );
      if (valueAsArray.length < 2 || !isValidValue(valueAsArray[0]) || !isValidValue(valueAsArray[1])) {
        return "";
      }
      return defaultValueProcessorByRule({ ...rule, value: valueAsArray }, opts);
    }
    case "in":
    case "notin": {
      const valueAsArray = toArray(rule.value);
      if (valueAsArray.length === 0) return "";
      const valStringArray = valueAsArray.map(
        (v) => valueIsField ? wrapFieldName(
          getOption(fields ?? /* istanbul ignore next */
          [], v)?.label ?? v
        ) : shouldRenderAsNumber(v, parseNumbers) ? `${trimIfString(v)}` : `${wrapAndEscape(v)}`
      );
      return `${valStringArray.slice(0, -1).join(", ")}${valStringArray.length > 2 ? "," : ""} ${orTL} ${valStringArray.at(-1)}`;
    }
  }
  if (typeof rule.value === "boolean") {
    return rule.value ? trueTL : falseTL;
  }
  return valueIsField ? wrapFieldName(
    getOption(fields ?? /* istanbul ignore next */
    [], rule.value)?.label ?? rule.value
  ) : shouldRenderAsNumber(rule.value, parseNumbers) ? `${trimIfString(rule.value)}` : `${wrapAndEscape(rule.value)}`;
};

// src/utils/formatQuery/defaultRuleProcessorNL.ts
var defaultExportOperatorMap = {
  "=": ["is", "is the same as the value in"],
  "!=": ["is not", "is not the same as the value in"],
  "<": ["is less than", "is less than the value in"],
  ">": ["is greater than", "is greater than the value in"],
  "<=": ["is less than or equal to", "is less than or equal to the value in"],
  ">=": ["is greater than or equal to", "is greater than or equal to the value in"],
  contains: ["contains", "contains the value in"],
  beginswith: ["starts with", "starts with the value in"],
  endswith: ["ends with", "ends with the value in"],
  doesnotcontain: ["does not contain", "does not contain the value in"],
  doesnotbeginwith: ["does not start with", "does not start with the value in"],
  doesnotendwith: ["does not end with", "does not end with the value in"],
  null: "is null",
  notnull: "is not null",
  in: ["is one of the values", "is the same as a value in"],
  notin: ["is not one of the values", "is not the same as any value in"],
  between: ["is between", "is between the values in"],
  notbetween: ["is not between", "is not between the values in"]
};
var defaultGetOperators = () => [];
var defaultOperatorProcessorNL = (rule, opts = {}) => {
  const { field, operator, valueSource = "value" } = rule;
  const {
    getOperators = defaultGetOperators,
    operatorMap: operatorMapParam = defaultExportOperatorMap
  } = opts;
  const mapOperatorMap = new Map(
    Object.entries(defaultExportOperatorMap)
  );
  for (const [key, value] of Object.entries(operatorMapParam)) {
    mapOperatorMap.set(lc(key), value);
  }
  const operatorMap = Object.fromEntries(mapOperatorMap);
  const { value: operatorNL, label } = getOption(
    toFullOptionList(
      getOperators(field, {
        fieldData: opts.fieldData ?? {
          name: field,
          value: field,
          label: field
        }
      }) ?? /* istanbul ignore next */
      []
    ),
    operator
  ) ?? {
    name: operator,
    value: operator,
    label: operator
  };
  const operatorTL = operatorMap[operatorNL] ?? operatorMap[lc(operatorNL)] ?? [label, label];
  return typeof operatorTL === "string" ? operatorTL : operatorTL[valueSource === "field" ? 1 : 0];
};
var defaultRuleProcessorNL = (rule, opts) => {
  const { field, operator } = rule;
  const {
    fieldData,
    quoteFieldNamesWith = ["", ""],
    fieldIdentifierSeparator = "",
    quoteValuesWith = `'`,
    operatorProcessor = defaultOperatorProcessorNL,
    valueProcessor = defaultValueProcessorNL,
    concatOperator = "||",
    wordOrder = "SVO"
  } = opts ?? /* istanbul ignore next */
  {};
  const processedField = getQuotedFieldName(fieldData?.label ?? field, {
    quoteFieldNamesWith,
    fieldIdentifierSeparator
  });
  const matchEval = processMatchMode(rule);
  if (matchEval === false) {
    return "";
  } else if (matchEval) {
    const { mode, threshold } = matchEval;
    const nestedArrayFilter = defaultRuleGroupProcessorNL(rule.value, {
      ...opts,
      fields: toFullOptionList(fieldData?.subproperties ?? [])
    });
    const hsp = (fieldData?.subproperties?.length ?? 0) > 0;
    switch (mode) {
      case "all":
        return `(${hsp ? "for " : ""}every item in ${processedField}${hsp ? "," : ""} ${nestedArrayFilter})`;
      case "none":
        return `(${hsp ? "for " : ""}no item in ${processedField}${hsp ? "," : ""} ${nestedArrayFilter})`;
      case "some":
        return `(${hsp ? "for " : ""}at least one item in ${processedField}${hsp ? "," : ""} ${nestedArrayFilter})`;
      case "atleast":
      case "atmost":
      case "exactly": {
        const mm = mode.replace("at", "at ");
        if (threshold > 0 && threshold < 1) {
          return `(${hsp ? "for " : ""}${mm} ${threshold * 100}% of the items in ${processedField}${hsp ? "," : ""} ${nestedArrayFilter})`;
        }
        return `(${hsp ? "for " : ""}${mm} ${threshold} of the items in ${processedField}${hsp ? "," : ""} ${nestedArrayFilter})`;
      }
    }
  }
  const value = valueProcessor(rule, {
    ...opts,
    quoteFieldNamesWith,
    fieldIdentifierSeparator,
    quoteValuesWith,
    concatOperator
  });
  const operatorLC = lc(operator);
  if ((operatorLC === "in" || operatorLC === "notin" || operatorLC === "between" || operatorLC === "notbetween") && !value) {
    return "";
  }
  const processedOperator = operatorProcessor(rule, opts);
  const wordOrderMap = {
    S: processedField,
    V: processedOperator,
    O: value
  };
  return normalizeConstituentWordOrder(wordOrder).map((term) => `${wordOrderMap[term]}`).join(" ").trim();
};

// src/utils/formatQuery/defaultRuleProcessorSQL.ts
var defaultOperatorProcessorSQL = (rule) => lc(mapSQLOperator(rule.operator));
var defaultRuleProcessorSQL = (rule, opts = {}) => {
  const {
    quoteFieldNamesWith = ["", ""],
    fieldIdentifierSeparator = "",
    quoteValuesWith = `'`,
    operatorProcessor = defaultOperatorProcessorSQL,
    valueProcessor = defaultValueProcessorByRule,
    concatOperator = "||"
  } = opts;
  const wrapFieldName = (v) => getQuotedFieldName(v, { quoteFieldNamesWith, fieldIdentifierSeparator });
  const ruleField = wrapFieldName(rule.field);
  const matchEval = processMatchMode(rule);
  if (matchEval === false) {
    return;
  } else if (matchEval) {
    if (opts?.preset !== "postgresql") return "";
    const { mode, threshold } = matchEval;
    const arrayElementAlias = "elem_alias";
    const nestedArrayFilter = defaultRuleGroupProcessorSQL(
      transformQuery(rule.value, {
        ruleProcessor: (r) => ({ ...r, field: arrayElementAlias })
      }),
      opts
    );
    switch (mode) {
      case "all":
        return `(select count(*) from unnest(${ruleField}) as ${wrapFieldName(arrayElementAlias)} where ${nestedArrayFilter}) = array_length(${ruleField}, 1)`;
      case "none":
        return `not exists (select 1 from unnest(${ruleField}) as ${wrapFieldName(arrayElementAlias)} where ${nestedArrayFilter})`;
      case "some":
        return `exists (select 1 from unnest(${ruleField}) as ${wrapFieldName(arrayElementAlias)} where ${nestedArrayFilter})`;
      case "atleast":
      case "atmost":
      case "exactly": {
        const op = mode === "atleast" ? ">=" : mode === "atmost" ? "<=" : "=";
        return `(select count(*)${threshold > 0 && threshold < 1 ? ` / array_length(${ruleField}, 1)` : ""} from unnest(${ruleField}) as ${wrapFieldName(arrayElementAlias)} where ${nestedArrayFilter}) ${op} ${threshold}`;
      }
    }
  }
  const value = valueProcessor(rule, {
    ...opts,
    quoteFieldNamesWith,
    fieldIdentifierSeparator,
    quoteValuesWith,
    concatOperator
  });
  const operator = operatorProcessor(rule, opts);
  const operatorLowerCase = lc(operator);
  if ((operatorLowerCase === "in" || operatorLowerCase === "not in" || operatorLowerCase === "between" || operatorLowerCase === "not between") && !value) {
    return "";
  }
  return `${ruleField} ${operator} ${value}`.trim();
};

// src/utils/formatQuery/defaultRuleProcessorParameterized.ts
var defaultRuleProcessorParameterized = (rule, opts, meta) => {
  const {
    fieldData,
    format,
    getNextNamedParam,
    parseNumbers,
    paramPrefix,
    paramsKeepPrefix,
    numberedParams,
    quoteFieldNamesWith = ["", ""],
    fieldIdentifierSeparator,
    concatOperator,
    operatorProcessor = defaultOperatorProcessorSQL,
    valueProcessor = defaultValueProcessorByRule
  } = opts ?? {};
  const { processedParams = [] } = meta ?? {};
  const parameterized = format === "parameterized";
  const params = [];
  const paramsNamed = {};
  const finalize = (sql) => parameterized ? { sql, params } : { sql, params: paramsNamed };
  const wrapFieldName = (v) => getQuotedFieldName(v, { quoteFieldNamesWith, fieldIdentifierSeparator });
  const ruleField = wrapFieldName(rule.field);
  const matchEval = processMatchMode(rule);
  if (matchEval === false) {
    return;
  } else if (matchEval) {
    if (opts?.preset !== "postgresql") return finalize("");
    const { mode, threshold } = matchEval;
    const arrayElementAlias = "elem_alias";
    const { sql: nestedSQL, params: nestedParams } = defaultRuleGroupProcessorParameterized(
      transformQuery(rule.value, {
        ruleProcessor: (r) => ({ ...r, field: arrayElementAlias })
      }),
      { ...opts, fields: [] }
    );
    if (Array.isArray(nestedParams)) {
      params.push(...nestedParams);
    } else {
      Object.assign(paramsNamed, nestedParams);
    }
    switch (mode) {
      case "all":
        return finalize(
          `(select count(*) from unnest(${ruleField}) as ${wrapFieldName(arrayElementAlias)} where ${nestedSQL}) = array_length(${ruleField}, 1)`
        );
      case "none":
        return finalize(
          `not exists (select 1 from unnest(${ruleField}) as ${wrapFieldName(arrayElementAlias)} where ${nestedSQL})`
        );
      case "some":
        return finalize(
          `exists (select 1 from unnest(${ruleField}) as ${wrapFieldName(arrayElementAlias)} where ${nestedSQL})`
        );
      case "atleast":
      case "atmost":
      case "exactly": {
        const op = mode === "atleast" ? ">=" : mode === "atmost" ? "<=" : "=";
        return finalize(
          `(select count(*)${threshold > 0 && threshold < 1 ? ` / array_length(${ruleField}, 1)` : ""} from unnest(${ruleField}) as ${wrapFieldName(arrayElementAlias)} where ${nestedSQL}) ${op} ${threshold}`
        );
      }
    }
  }
  const value = valueProcessor(rule, {
    parseNumbers,
    quoteFieldNamesWith,
    concatOperator,
    fieldData,
    format
  });
  const sqlOperator = operatorProcessor(rule, opts);
  const sqlOperatorLowerCase = lc(sqlOperator);
  const [qPre, qPost] = quoteFieldNamesWith;
  if ((sqlOperatorLowerCase === "in" || sqlOperatorLowerCase === "not in" || sqlOperatorLowerCase === "between" || sqlOperatorLowerCase === "not between") && !value) {
    return finalize("");
  } else if (sqlOperatorLowerCase === "is null" || sqlOperatorLowerCase === "is not null") {
    return finalize(`${qPre}${rule.field}${qPost} ${sqlOperator}`);
  } else if (rule.valueSource === "field") {
    return finalize(`${qPre}${rule.field}${qPost} ${sqlOperator} ${value}`.trim());
  } else if (sqlOperatorLowerCase === "in" || sqlOperatorLowerCase === "not in") {
    const splitValue = toArray(rule.value);
    if (parameterized) {
      for (const v of splitValue) {
        params.push(shouldRenderAsNumber(v, parseNumbers) ? parseNumber(v, { parseNumbers }) : v);
      }
      return finalize(
        `${qPre}${rule.field}${qPost} ${sqlOperator} (${splitValue.map(
          (_v, i) => numberedParams ? `${paramPrefix}${processedParams.length + 1 + splitValue.length - (splitValue.length - i)}` : "?"
        ).join(", ")})`
      );
    }
    const inParams = [];
    for (const v of splitValue) {
      const thisParamName = getNextNamedParam(rule.field);
      inParams.push(`${paramPrefix}${thisParamName}`);
      paramsNamed[`${paramsKeepPrefix ? paramPrefix : ""}${thisParamName}`] = shouldRenderAsNumber(
        v,
        parseNumbers
      ) ? parseNumber(v, { parseNumbers }) : v;
    }
    return finalize(`${qPre}${rule.field}${qPost} ${sqlOperator} (${inParams.join(", ")})`);
  } else if (sqlOperatorLowerCase === "between" || sqlOperatorLowerCase === "not between") {
    const valueAsArray = toArray(rule.value, { retainEmptyStrings: true });
    const [first, second] = valueAsArray.slice(0, 2).map((v) => shouldRenderAsNumber(v, parseNumbers) ? parseNumber(v, { parseNumbers }) : v);
    if (parameterized) {
      params.push(first, second);
      return finalize(
        `${qPre}${rule.field}${qPost} ${sqlOperator} ${numberedParams ? `${paramPrefix}${processedParams.length + 1}` : "?"} and ${numberedParams ? `${paramPrefix}${processedParams.length + 2}` : "?"}`
      );
    }
    const firstParamName = getNextNamedParam(rule.field);
    const secondParamName = getNextNamedParam(rule.field);
    paramsNamed[`${paramsKeepPrefix ? paramPrefix : ""}${firstParamName}`] = first;
    paramsNamed[`${paramsKeepPrefix ? paramPrefix : ""}${secondParamName}`] = second;
    return finalize(
      `${qPre}${rule.field}${qPost} ${sqlOperator} ${paramPrefix}${firstParamName} and ${paramPrefix}${secondParamName}`
    );
  }
  let paramValue = rule.value;
  if (typeof rule.value === "string") {
    if (shouldRenderAsNumber(rule.value, parseNumbers)) {
      paramValue = parseNumber(rule.value, { parseNumbers });
    } else {
      paramValue = /^'.*'$/g.test(value) ? value.replaceAll(/(^'|'$)/g, "") : (
        /* istanbul ignore next */
        value
      );
    }
  }
  let paramName = "";
  if (parameterized) {
    params.push(paramValue);
  } else {
    paramName = getNextNamedParam(rule.field);
    paramsNamed[`${paramsKeepPrefix ? paramPrefix : ""}${paramName}`] = paramValue;
  }
  return finalize(
    `${qPre}${rule.field}${qPost} ${sqlOperator} ${parameterized ? numberedParams ? `${paramPrefix}${processedParams.length + 1}` : "?" : `${paramPrefix}${paramName}`}`.trim()
  );
};

// src/utils/formatQuery/defaultRuleProcessorPrisma.ts
var processNumber2 = (value, fallback, parseNumbers) => shouldRenderAsNumber(value, !!parseNumbers || typeof value === "bigint") ? Number(parseNumber(value, { parseNumbers: !!parseNumbers })) : fallback;
var defaultRuleProcessorPrisma = (rule, options = {}) => {
  const { field, operator, value, valueSource } = rule;
  const { parseNumbers, preserveValueOrder } = options;
  if (valueSource === "field" || processMatchMode(rule)) return;
  const operatorLC = lc(operator);
  switch (operatorLC) {
    case "=":
      return { [field]: processNumber2(value, value, parseNumbers) };
    case "!=":
    case "<":
    case "<=":
    case ">":
    case ">=": {
      const prismaOperator = prismaOperators[operatorLC];
      return {
        [field]: {
          [prismaOperator]: processNumber2(value, value, parseNumbers)
        }
      };
    }
    case "contains":
      return { [field]: { contains: value } };
    case "beginswith":
      return { [field]: { startsWith: value } };
    case "endswith":
      return { [field]: { endsWith: value } };
    case "doesnotcontain":
      return { NOT: { [field]: { contains: value } } };
    case "doesnotbeginwith":
      return { NOT: { [field]: { startsWith: value } } };
    case "doesnotendwith":
      return { NOT: { [field]: { endsWith: value } } };
    case "null":
      return { [field]: null };
    case "notnull":
      return { [field]: { not: null } };
    case "in":
    case "notin": {
      const valueAsArray = toArray(value);
      return {
        [field]: {
          [prismaOperators[operatorLC]]: valueAsArray.map(
            (val) => processNumber2(val, val, parseNumbers)
          )
        }
      };
    }
    case "between":
    case "notbetween": {
      const valueAsArray = toArray(value);
      if (valueAsArray.length >= 2 && isValidValue(valueAsArray[0]) && isValidValue(valueAsArray[1])) {
        const [first, second] = valueAsArray;
        const shouldParseNumbers = !(parseNumbers === false);
        const firstNum = shouldRenderAsNumber(first, shouldParseNumbers) ? parseNumber(first, { parseNumbers }) : Number.NaN;
        const secondNum = shouldRenderAsNumber(second, shouldParseNumbers) ? parseNumber(second, { parseNumbers }) : Number.NaN;
        let firstValue = Number.isNaN(firstNum) ? first : firstNum;
        let secondValue = Number.isNaN(secondNum) ? second : secondNum;
        if (!preserveValueOrder && firstValue === firstNum && secondValue === secondNum && secondNum < firstNum) {
          const tempNum = secondNum;
          secondValue = firstNum;
          firstValue = tempNum;
        }
        return operatorLC === "between" ? { [field]: { gte: firstValue, lte: secondValue } } : { OR: [{ [field]: { lt: firstValue } }, { [field]: { gt: secondValue } }] };
      } else {
        return "";
      }
    }
  }
  return "";
};

// src/utils/formatQuery/defaultRuleProcessorSequelize.ts
var defaultRuleProcessorSequelize = (rule, { parseNumbers, preserveValueOrder, context = {} } = {}) => {
  const {
    sequelizeOperators: Op,
    sequelizeCol: col,
    sequelizeFn: fn
  } = context;
  if (processMatchMode(rule)) return;
  const { field, operator, value, valueSource } = rule;
  const valueIsField = valueSource === "field";
  const operatorLC = lc(operator);
  if (
    // Bail out if we don't have the Op symbols
    !Op || // ...or valueSource is 'field' and we don't have the `col` function,
    valueIsField && (!col || // ...or valueSource is 'field' and we don't have the `fn` function
    // and the operator is one of the "doesNot*" ones
    !fn && ["doesnotcontain", "doesnotbeginwith", "doesnotendwith"].includes(operatorLC))
  ) {
    return;
  }
  switch (operatorLC) {
    case "=":
    case "!=":
    case "<":
    case "<=":
    case ">":
    case ">=": {
      const sequelizeOperator = {
        "=": Op.eq,
        "!=": Op.ne,
        "<": Op.lt,
        "<=": Op.lte,
        ">": Op.gt,
        ">=": Op.gte
      }[operatorLC];
      return {
        [field]: valueIsField && operatorLC === "=" ? { [Op.col]: value } : {
          [sequelizeOperator]: valueIsField ? col(value) : shouldRenderAsNumber(value, parseNumbers) ? parseNumber(value, { parseNumbers: "strict" }) : value
        }
      };
    }
    case "contains":
      return { [field]: { [Op.substring]: valueIsField ? col(value) : `${value}` } };
    case "beginswith":
      return { [field]: { [Op.startsWith]: valueIsField ? col(value) : `${value}` } };
    case "endswith":
      return { [field]: { [Op.endsWith]: valueIsField ? col(value) : `${value}` } };
    case "doesnotcontain":
      return {
        [field]: {
          [Op.notLike]: valueIsField ? fn("CONCAT", "%", col(value), "%") : `%${value}%`
        }
      };
    case "doesnotbeginwith":
      return {
        [field]: { [Op.notLike]: valueIsField ? fn("CONCAT", col(value), "%") : `${value}%` }
      };
    case "doesnotendwith":
      return {
        [field]: { [Op.notLike]: valueIsField ? fn("CONCAT", "%", col(value)) : `%${value}` }
      };
    case "null":
      return { [field]: { [Op.is]: null } };
    case "notnull":
      return { [field]: { [Op.not]: null } };
    case "in":
    case "notin": {
      const valueAsArray = toArray(value);
      return {
        [field]: {
          [operatorLC === "in" ? Op.in : Op.notIn]: valueAsArray.map(
            (val) => valueIsField ? col(val) : shouldRenderAsNumber(val, parseNumbers) ? parseNumber(val, { parseNumbers: "strict" }) : val
          )
        }
      };
    }
    case "between":
    case "notbetween": {
      const valueAsArray = toArray(value, { retainEmptyStrings: true });
      if (valueAsArray.length < 2 || !isValidValue(valueAsArray[0]) || !isValidValue(valueAsArray[1])) {
        return;
      }
      const [first, second] = valueAsArray;
      const firstNum = shouldRenderAsNumber(first, parseNumbers) ? parseNumber(first, { parseNumbers: "strict" }) : Number.NaN;
      const secondNum = shouldRenderAsNumber(second, parseNumbers) ? parseNumber(second, { parseNumbers: "strict" }) : Number.NaN;
      const firstValue = Number.isNaN(firstNum) ? first : firstNum;
      const secondValue = Number.isNaN(secondNum) ? second : secondNum;
      const valsOneAndTwoOnly = [firstValue, secondValue];
      if (!preserveValueOrder && firstValue === firstNum && secondValue === secondNum && secondNum < firstNum) {
        valsOneAndTwoOnly[0] = secondNum;
        valsOneAndTwoOnly[1] = firstNum;
      }
      return {
        [field]: {
          [operatorLC === "between" ? Op.between : Op.notBetween]: valueIsField ? valsOneAndTwoOnly.map((v) => col(v)) : valsOneAndTwoOnly.every((v) => shouldRenderAsNumber(v, parseNumbers)) ? valsOneAndTwoOnly.map((v) => parseNumber(v, { parseNumbers: "strict" })) : valsOneAndTwoOnly
        }
      };
    }
  }
  return;
};

// src/utils/formatQuery/formatQuery.ts
var import_immer4 = require("immer");
var sqlDialectPresets = {
  ansi: {},
  // This should always be empty
  sqlite: {
    paramsKeepPrefix: true
  },
  oracle: {},
  mssql: {
    concatOperator: "+",
    quoteFieldNamesWith: ["[", "]"],
    fieldIdentifierSeparator: ".",
    paramPrefix: "@"
  },
  mysql: {
    concatOperator: "CONCAT"
  },
  postgresql: {
    quoteFieldNamesWith: '"',
    numberedParams: true,
    paramPrefix: "$"
  }
};
var formatQueryOptionPresets = {
  ...sqlDialectPresets
};
var defaultRuleProcessors = {
  cel: defaultRuleProcessorCEL,
  drizzle: defaultRuleProcessorDrizzle,
  elasticsearch: defaultRuleProcessorElasticSearch,
  json_without_ids: defaultRuleProcessorSQL,
  json: defaultRuleProcessorSQL,
  jsonata: defaultRuleProcessorJSONata,
  jsonlogic: defaultRuleProcessorJsonLogic,
  ldap: defaultRuleProcessorLDAP,
  mongodb_query: defaultRuleProcessorMongoDBQuery,
  mongodb: defaultRuleProcessorMongoDB,
  natural_language: defaultRuleProcessorNL,
  parameterized_named: defaultRuleProcessorParameterized,
  parameterized: defaultRuleProcessorParameterized,
  prisma: defaultRuleProcessorPrisma,
  sequelize: defaultRuleProcessorSequelize,
  spel: defaultRuleProcessorSpEL,
  sql: defaultRuleProcessorSQL
};
var defaultOperatorProcessor = (r) => r.operator;
var defaultOperatorProcessors = {
  cel: defaultOperatorProcessor,
  drizzle: defaultOperatorProcessor,
  elasticsearch: defaultOperatorProcessor,
  json_without_ids: defaultOperatorProcessor,
  json: defaultOperatorProcessor,
  jsonata: defaultOperatorProcessor,
  jsonlogic: defaultOperatorProcessor,
  ldap: defaultOperatorProcessor,
  mongodb_query: defaultOperatorProcessor,
  mongodb: defaultOperatorProcessor,
  natural_language: defaultOperatorProcessorNL,
  parameterized_named: defaultOperatorProcessorSQL,
  parameterized: defaultOperatorProcessorSQL,
  prisma: defaultOperatorProcessor,
  sequelize: defaultOperatorProcessor,
  spel: defaultOperatorProcessor,
  sql: defaultOperatorProcessorSQL
};
var defaultFallbackExpressions = {
  cel: "1 == 1",
  ldap: "",
  mongodb: '"$and":[{"$expr":true}]',
  natural_language: "1 is 1",
  spel: "1 == 1",
  sql: "(1 = 1)"
};
var defaultFormatQueryOptions = {
  format: "json",
  fields: [],
  quoteFieldNamesWith: ["", ""],
  fieldIdentifierSeparator: "",
  getOperators: () => [],
  paramPrefix: ":",
  paramsKeepPrefix: false,
  numberedParams: false,
  preserveValueOrder: false,
  placeholderFieldName: defaultPlaceholderFieldName,
  placeholderOperatorName: defaultPlaceholderOperatorName,
  quoteValuesWith: "'",
  concatOperator: "||",
  preset: "ansi",
  wordOrder: "SVO",
  translations: {},
  operatorMap: {}
};
var valueProcessorCanActAsRuleProcessor = /* @__PURE__ */ new Set([
  "cel",
  "drizzle",
  "elasticsearch",
  "jsonata",
  "jsonlogic",
  "ldap",
  "mongodb_query",
  "mongodb",
  "prisma",
  "sequelize",
  "spel"
]);
var sqlFormats = /* @__PURE__ */ new Set([
  "sql",
  "parameterized",
  "parameterized_named",
  "drizzle",
  "prisma",
  "sequelize"
]);
function formatQuery(ruleGroup, optionParam = {}) {
  const options = typeof optionParam === "string" ? { format: lc(optionParam) } : optionParam;
  const optObj = {
    ...defaultFormatQueryOptions,
    ...!options.format || sqlFormats.has(options.format) ? sqlDialectPresets[options.preset ?? "ansi"] ?? null : null,
    ...options,
    ...!options.format && (Object.keys(sqlDialectPresets).includes(options.preset ?? "") ? { format: "sql" } : null)
  };
  const format = lc(optObj.format);
  const {
    fallbackExpression: fallbackExpression_option,
    getOperators: getOperators_option,
    operatorProcessor: operatorProcessor_option,
    parseNumbers,
    quoteFieldNamesWith: quoteFieldNamesWith_option,
    ruleGroupProcessor: ruleGroupProcessor_option,
    ruleProcessor: ruleProcessor_option,
    validator,
    valueProcessor: valueProcessor_option,
    context
  } = optObj;
  const getParseNumberBoolean = (inputType) => {
    const parseNumberMethod = getParseNumberMethod({ parseNumbers, inputType });
    return typeof parseNumberMethod === "string" ? true : typeof parseNumbers === "boolean" ? parseNumbers : void 0;
  };
  const operatorProcessor = typeof operatorProcessor_option === "function" ? operatorProcessor_option : defaultOperatorProcessors[format] ?? defaultOperatorProcessor;
  const valueProcessor = typeof valueProcessor_option === "function" ? isValueProcessorLegacy(valueProcessor_option) ? (r) => valueProcessor_option(r.field, r.operator, r.value, r.valueSource) : valueProcessor_option : format === "natural_language" ? defaultValueProcessorNL : valueProcessorCanActAsRuleProcessor.has(format) ? ruleProcessor_option ?? defaultRuleProcessors[format] : defaultValueProcessorByRule;
  const ruleProcessor = (typeof ruleProcessor_option === "function" ? ruleProcessor_option : null) ?? (valueProcessorCanActAsRuleProcessor.has(format) && typeof ruleProcessor_option !== "function" && valueProcessor_option ? valueProcessor : null) ?? defaultRuleProcessors[format] ?? defaultRuleProcessorSQL;
  const quoteFieldNamesWith = getQuoteFieldNamesWithArray(quoteFieldNamesWith_option);
  const fields = toFullOptionList(optObj.fields);
  const getOperators = (f, m) => toFullOptionList(getOperators_option(f, m) ?? /* istanbul ignore next */
  []);
  const fallbackExpression = fallbackExpression_option ?? defaultFallbackExpressions[format] ?? defaultFallbackExpressions.sql;
  let validationMap = {};
  if (typeof validator === "function") {
    const validationResult = validator(ruleGroup);
    if (typeof validationResult === "boolean") {
      if (validationResult === false) {
        return format === "parameterized" ? { sql: fallbackExpression, params: [] } : format === "parameterized_named" ? { sql: fallbackExpression, params: {} } : format === "mongodb" ? `{${fallbackExpression}}` : format === "mongodb_query" ? mongoDbFallback : format === "prisma" ? prismaFallback : format === "jsonlogic" ? false : format === "elasticsearch" ? {} : format === "drizzle" || format === "sequelize" ? void 0 : fallbackExpression;
      }
    } else {
      validationMap = validationResult;
    }
  }
  const validatorMap = {};
  const uniqueFields = toFlatOptionArray(fields);
  for (const f of uniqueFields) {
    if (typeof f.validator === "function") {
      validatorMap[f.value ?? /* istanbul ignore next */
      f.name] = f.validator;
    }
  }
  const validateRule = (rule) => {
    let validationResult;
    let fieldValidator;
    if (rule.id) {
      validationResult = validationMap[rule.id];
    }
    if (uniqueFields.length > 0) {
      const fieldArr = uniqueFields.filter((f) => f.name === rule.field);
      if (fieldArr.length > 0) {
        const field = fieldArr[0];
        if (typeof field.validator === "function") {
          fieldValidator = field.validator;
        }
      }
    }
    return [validationResult, fieldValidator];
  };
  const finalOptions = {
    ...optObj,
    fallbackExpression,
    fields,
    format,
    getOperators,
    getParseNumberBoolean,
    quoteFieldNamesWith,
    operatorProcessor,
    ruleProcessor,
    valueProcessor,
    validateRule,
    validationMap,
    context
  };
  if (typeof ruleGroupProcessor_option === "function") {
    return ruleGroupProcessor_option(ruleGroup, finalOptions);
  }
  switch (format) {
    case "json":
    case "json_without_ids": {
      const rg = parseNumbers ? (0, import_immer4.produce)(ruleGroup, (g) => numerifyValues(g, finalOptions)) : ruleGroup;
      if (format === "json_without_ids") {
        return JSON.stringify(
          rg,
          (key, value) => (
            // Remove `id` and `path` keys; leave everything else unchanged.
            key === "id" || key === "path" ? void 0 : bigIntJsonStringifyReplacer(key, value)
          )
        );
      }
      return JSON.stringify(rg, bigIntJsonStringifyReplacer, 2);
    }
    case "sql":
      return defaultRuleGroupProcessorSQL(ruleGroup, finalOptions);
    case "parameterized":
    case "parameterized_named":
      return defaultRuleGroupProcessorParameterized(ruleGroup, finalOptions);
    case "mongodb":
      return defaultRuleGroupProcessorMongoDB(ruleGroup, finalOptions);
    case "mongodb_query":
      return defaultRuleGroupProcessorMongoDBQuery(ruleGroup, finalOptions);
    case "cel":
      return defaultRuleGroupProcessorCEL(ruleGroup, finalOptions);
    case "spel":
      return defaultRuleGroupProcessorSpEL(ruleGroup, finalOptions);
    case "jsonata":
      return defaultRuleGroupProcessorJSONata(ruleGroup, finalOptions);
    case "jsonlogic":
      return defaultRuleGroupProcessorJsonLogic(ruleGroup, finalOptions);
    case "elasticsearch":
      return defaultRuleGroupProcessorElasticSearch(ruleGroup, finalOptions);
    case "natural_language":
      return defaultRuleGroupProcessorNL(ruleGroup, finalOptions);
    case "ldap":
      return defaultRuleGroupProcessorLDAP(ruleGroup, finalOptions);
    case "prisma":
      return defaultRuleGroupProcessorPrisma(ruleGroup, finalOptions);
    case "drizzle":
      return defaultRuleGroupProcessorDrizzle(ruleGroup, finalOptions);
    case "sequelize":
      return defaultRuleGroupProcessorSequelize(ruleGroup, finalOptions);
    default:
      return "";
  }
}

// src/utils/formatQuery/index.ts
var generateValueProcessor = (vpbr) => (field, operator, value, valueSource) => vpbr({ field, operator, value, valueSource }, { parseNumbers: false });
var defaultValueProcessor = generateValueProcessor(
  defaultValueProcessorByRule
);
var defaultMongoDBValueProcessor = generateValueProcessor(
  defaultRuleProcessorMongoDB
);
var defaultCELValueProcessor = generateValueProcessor(defaultRuleProcessorCEL);
var defaultSpELValueProcessor = generateValueProcessor(defaultRuleProcessorSpEL);
var defaultValueProcessorCELByRule = defaultRuleProcessorCEL;
var defaultValueProcessorMongoDBByRule = defaultRuleProcessorMongoDB;
var defaultValueProcessorSpELByRule = defaultRuleProcessorSpEL;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  bigIntJsonParseReviver,
  bigIntJsonStringifyReplacer,
  celCombinatorMap,
  defaultCELValueProcessor,
  defaultExportOperatorMap,
  defaultMongoDBValueProcessor,
  defaultNLTranslations,
  defaultOperatorProcessorNL,
  defaultOperatorProcessorSQL,
  defaultRuleGroupProcessorCEL,
  defaultRuleGroupProcessorDrizzle,
  defaultRuleGroupProcessorElasticSearch,
  defaultRuleGroupProcessorJSONata,
  defaultRuleGroupProcessorJsonLogic,
  defaultRuleGroupProcessorLDAP,
  defaultRuleGroupProcessorMongoDB,
  defaultRuleGroupProcessorMongoDBQuery,
  defaultRuleGroupProcessorNL,
  defaultRuleGroupProcessorParameterized,
  defaultRuleGroupProcessorPrisma,
  defaultRuleGroupProcessorSQL,
  defaultRuleGroupProcessorSequelize,
  defaultRuleGroupProcessorSpEL,
  defaultRuleProcessorCEL,
  defaultRuleProcessorDrizzle,
  defaultRuleProcessorElasticSearch,
  defaultRuleProcessorJSONata,
  defaultRuleProcessorJsonLogic,
  defaultRuleProcessorLDAP,
  defaultRuleProcessorMongoDB,
  defaultRuleProcessorMongoDBQuery,
  defaultRuleProcessorNL,
  defaultRuleProcessorParameterized,
  defaultRuleProcessorPrisma,
  defaultRuleProcessorSQL,
  defaultRuleProcessorSequelize,
  defaultRuleProcessorSpEL,
  defaultSpELValueProcessor,
  defaultValueProcessor,
  defaultValueProcessorByRule,
  defaultValueProcessorCELByRule,
  defaultValueProcessorMongoDBByRule,
  defaultValueProcessorNL,
  defaultValueProcessorSpELByRule,
  formatQuery,
  formatQueryOptionPresets,
  getNLTranslataion,
  getQuoteFieldNamesWithArray,
  getQuotedFieldName,
  isValidValue,
  isValueProcessorLegacy,
  jsonLogicAdditionalOperators,
  mapSQLOperator,
  mongoDbFallback,
  mongoOperators,
  normalizeConstituentWordOrder,
  numerifyValues,
  prismaFallback,
  prismaOperators,
  processMatchMode,
  shouldRenderAsNumber,
  sqlDialectPresets
});
//# sourceMappingURL=formatQuery.js.map