import {
  ActionElement,
  DragHandle,
  InlineCombinator,
  LogType,
  MatchModeEditor,
  NotToggle,
  QueryBuilderContext,
  QueryBuilderInternal,
  QueryBuilderStateContext,
  Rule,
  RuleComponents,
  RuleComponentsWithSubQuery,
  RuleGroup,
  RuleGroupBodyComponents,
  RuleGroupHeaderComponents,
  RuleWithSubQueryGroupComponentsWrapper,
  ShiftActions,
  TestID,
  ValueEditor,
  ValueSelector,
  add,
  bigIntJsonParseReviver,
  bigIntJsonStringifyReplacer,
  celCombinatorMap,
  convertFromIC,
  convertQuery,
  convertToIC,
  defaultCELValueProcessor,
  defaultCombinatorLabelMap,
  defaultCombinators,
  defaultCombinatorsExtended,
  defaultControlClassnames,
  defaultControlElements,
  defaultExportOperatorMap,
  defaultJoinChar,
  defaultMatchModes,
  defaultMongoDBValueProcessor,
  defaultNLTranslations,
  defaultOperatorLabelMap,
  defaultOperatorNegationMap,
  defaultOperatorProcessorNL,
  defaultOperatorProcessorSQL,
  defaultOperators,
  defaultPlaceholderFieldGroupLabel,
  defaultPlaceholderFieldLabel,
  defaultPlaceholderFieldName,
  defaultPlaceholderLabel,
  defaultPlaceholderName,
  defaultPlaceholderOperatorGroupLabel,
  defaultPlaceholderOperatorLabel,
  defaultPlaceholderOperatorName,
  defaultPlaceholderValueGroupLabel,
  defaultPlaceholderValueLabel,
  defaultPlaceholderValueName,
  defaultRuleGroupProcessorCEL,
  defaultRuleGroupProcessorDrizzle,
  defaultRuleGroupProcessorElasticSearch,
  defaultRuleGroupProcessorJSONata,
  defaultRuleGroupProcessorJsonLogic,
  defaultRuleGroupProcessorLDAP,
  defaultRuleGroupProcessorMongoDB,
  defaultRuleGroupProcessorMongoDBQuery,
  defaultRuleGroupProcessorNL,
  defaultRuleGroupProcessorParameterized,
  defaultRuleGroupProcessorPrisma,
  defaultRuleGroupProcessorSQL,
  defaultRuleGroupProcessorSequelize,
  defaultRuleGroupProcessorSpEL,
  defaultRuleProcessorCEL,
  defaultRuleProcessorDrizzle,
  defaultRuleProcessorElasticSearch,
  defaultRuleProcessorJSONata,
  defaultRuleProcessorJsonLogic,
  defaultRuleProcessorLDAP,
  defaultRuleProcessorMongoDB,
  defaultRuleProcessorMongoDBQuery,
  defaultRuleProcessorNL,
  defaultRuleProcessorParameterized,
  defaultRuleProcessorPrisma,
  defaultRuleProcessorSQL,
  defaultRuleProcessorSequelize,
  defaultRuleProcessorSpEL,
  defaultSpELValueProcessor,
  defaultTranslations,
  defaultValidator,
  defaultValueProcessor,
  defaultValueProcessorByRule,
  defaultValueProcessorCELByRule,
  defaultValueProcessorMongoDBByRule,
  defaultValueProcessorNL,
  defaultValueProcessorSpELByRule,
  filterFieldsByComparator,
  findID,
  findPath,
  formatQuery,
  formatQueryOptionPresets,
  generateAccessibleDescription,
  generateID,
  getCommonAncestorPath,
  getCompatContextProvider,
  getFirstOption,
  getMatchModesUtil,
  getNLTranslataion,
  getOption,
  getParentPath,
  getParseNumberMethod,
  getPathOfID,
  getQuerySelectorById,
  getQuoteFieldNamesWithArray,
  getQuotedFieldName,
  getValidationClassNames,
  getValueSourcesUtil,
  group,
  groupInvalidReasons,
  insert,
  isAncestor,
  isFlexibleOptionArray,
  isFlexibleOptionGroupArray,
  isFullOptionArray,
  isFullOptionGroupArray,
  isOptionGroupArray,
  isPojo,
  isRuleGroup,
  isRuleGroupType,
  isRuleGroupTypeIC,
  isRuleOrGroupValid,
  isValidValue,
  isValidationResult,
  isValueProcessorLegacy,
  joinWith,
  jsonLogicAdditionalOperators,
  lc,
  mapSQLOperator,
  mergeClassnames,
  mergeTranslation,
  mergeTranslations,
  messages,
  mongoDbFallback,
  mongoOperators,
  move,
  normalizeConstituentWordOrder,
  nullFreeArray,
  nullOrUndefinedOrEmpty,
  numericRegex,
  numerifyValues,
  objectEntries,
  objectKeys,
  parseNumber,
  pathIsDisabled,
  pathsAreEqual,
  preferProp,
  prepareRule,
  prepareRuleGroup,
  prepareRuleOrGroup,
  prismaFallback,
  prismaOperators,
  processMatchMode,
  regenerateID,
  regenerateIDs,
  remove,
  rootPath,
  shouldRenderAsNumber,
  splitBy,
  sqlDialectPresets,
  standardClassnames,
  storeCommon,
  toArray,
  toFlatOptionArray,
  toFullOption,
  toFullOptionList,
  toFullOptionMap,
  toOptions,
  transformQuery,
  trimIfString,
  uniqByIdentifier,
  uniqByName,
  uniqOptGroups,
  uniqOptList,
  update,
  useControlledOrUncontrolled,
  useDeprecatedProps,
  useFields,
  useMatchModeEditor,
  useMergedContext,
  usePreferAnyProp,
  usePreferProp,
  usePrevious,
  useQueryBuilder,
  useQueryBuilderQuery,
  useQueryBuilderSchema,
  useQueryBuilderSelector,
  useQueryBuilderSetup,
  useReactDndWarning,
  useRule,
  useRuleGroup,
  useSelectElementChangeHandler,
  useStopEventPropagation,
  useValueEditor,
  useValueSelector
} from "./chunk-WL5NAARS.js";

// src/redux/store.ts
import { configureStore } from "@reduxjs/toolkit";
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {})) if (__hasOwnProp.call(b, prop)) __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols) for (var prop of __getOwnPropSymbols(b)) {
    if (__propIsEnum.call(b, prop)) __defNormalProp(a, prop, b[prop]);
  }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var queryBuilderStore = configureStore(__spreadProps(__spreadValues({}, storeCommon), { devTools: false }));

// src/components/QueryBuilder.tsx
import { jsx as jsx2 } from "react/jsx-runtime";

// src/components/QueryBuilderStateProvider.tsx
import { jsx } from "react/jsx-runtime";
import { Provider } from "react-redux";
var QueryBuilderStateProvider = (props) => /* @__PURE__ */ jsx(Provider, { context: QueryBuilderStateContext, store: queryBuilderStore, children: props.children });

// src/components/QueryBuilder.tsx
var QueryBuilder = (props) => /* @__PURE__ */ jsx2(QueryBuilderStateProvider, { children: /* @__PURE__ */ jsx2(QueryBuilderInternal, { props }) });
export {
  ActionElement,
  DragHandle,
  InlineCombinator,
  LogType,
  MatchModeEditor,
  NotToggle,
  QueryBuilder,
  QueryBuilderContext,
  QueryBuilderStateContext,
  QueryBuilderStateProvider,
  Rule,
  RuleComponents,
  RuleComponentsWithSubQuery,
  RuleGroup,
  RuleGroupBodyComponents,
  RuleGroupHeaderComponents,
  RuleWithSubQueryGroupComponentsWrapper,
  ShiftActions,
  TestID,
  ValueEditor,
  ValueSelector,
  add,
  bigIntJsonParseReviver,
  bigIntJsonStringifyReplacer,
  celCombinatorMap,
  convertFromIC,
  convertQuery,
  convertToIC,
  QueryBuilder as default,
  defaultCELValueProcessor,
  defaultCombinatorLabelMap,
  defaultCombinators,
  defaultCombinatorsExtended,
  defaultControlClassnames,
  defaultControlElements,
  defaultExportOperatorMap,
  defaultJoinChar,
  defaultMatchModes,
  defaultMongoDBValueProcessor,
  defaultNLTranslations,
  defaultOperatorLabelMap,
  defaultOperatorNegationMap,
  defaultOperatorProcessorNL,
  defaultOperatorProcessorSQL,
  defaultOperators,
  defaultPlaceholderFieldGroupLabel,
  defaultPlaceholderFieldLabel,
  defaultPlaceholderFieldName,
  defaultPlaceholderLabel,
  defaultPlaceholderName,
  defaultPlaceholderOperatorGroupLabel,
  defaultPlaceholderOperatorLabel,
  defaultPlaceholderOperatorName,
  defaultPlaceholderValueGroupLabel,
  defaultPlaceholderValueLabel,
  defaultPlaceholderValueName,
  defaultRuleGroupProcessorCEL,
  defaultRuleGroupProcessorDrizzle,
  defaultRuleGroupProcessorElasticSearch,
  defaultRuleGroupProcessorJSONata,
  defaultRuleGroupProcessorJsonLogic,
  defaultRuleGroupProcessorLDAP,
  defaultRuleGroupProcessorMongoDB,
  defaultRuleGroupProcessorMongoDBQuery,
  defaultRuleGroupProcessorNL,
  defaultRuleGroupProcessorParameterized,
  defaultRuleGroupProcessorPrisma,
  defaultRuleGroupProcessorSQL,
  defaultRuleGroupProcessorSequelize,
  defaultRuleGroupProcessorSpEL,
  defaultRuleProcessorCEL,
  defaultRuleProcessorDrizzle,
  defaultRuleProcessorElasticSearch,
  defaultRuleProcessorJSONata,
  defaultRuleProcessorJsonLogic,
  defaultRuleProcessorLDAP,
  defaultRuleProcessorMongoDB,
  defaultRuleProcessorMongoDBQuery,
  defaultRuleProcessorNL,
  defaultRuleProcessorParameterized,
  defaultRuleProcessorPrisma,
  defaultRuleProcessorSQL,
  defaultRuleProcessorSequelize,
  defaultRuleProcessorSpEL,
  defaultSpELValueProcessor,
  defaultTranslations,
  defaultValidator,
  defaultValueProcessor,
  defaultValueProcessorByRule,
  defaultValueProcessorCELByRule,
  defaultValueProcessorMongoDBByRule,
  defaultValueProcessorNL,
  defaultValueProcessorSpELByRule,
  filterFieldsByComparator,
  findID,
  findPath,
  formatQuery,
  formatQueryOptionPresets,
  generateAccessibleDescription,
  generateID,
  getCommonAncestorPath,
  getCompatContextProvider,
  getFirstOption,
  getMatchModesUtil,
  getNLTranslataion,
  getOption,
  getParentPath,
  getParseNumberMethod,
  getPathOfID,
  getQuerySelectorById,
  getQuoteFieldNamesWithArray,
  getQuotedFieldName,
  getValidationClassNames,
  getValueSourcesUtil,
  group,
  groupInvalidReasons,
  insert,
  isAncestor,
  isFlexibleOptionArray,
  isFlexibleOptionGroupArray,
  isFullOptionArray,
  isFullOptionGroupArray,
  isOptionGroupArray,
  isPojo,
  isRuleGroup,
  isRuleGroupType,
  isRuleGroupTypeIC,
  isRuleOrGroupValid,
  isValidValue,
  isValidationResult,
  isValueProcessorLegacy,
  joinWith,
  jsonLogicAdditionalOperators,
  lc,
  mapSQLOperator,
  mergeClassnames,
  mergeTranslation,
  mergeTranslations,
  messages,
  mongoDbFallback,
  mongoOperators,
  move,
  normalizeConstituentWordOrder,
  nullFreeArray,
  nullOrUndefinedOrEmpty,
  numericRegex,
  numerifyValues,
  objectEntries,
  objectKeys,
  parseNumber,
  pathIsDisabled,
  pathsAreEqual,
  preferProp,
  prepareRule,
  prepareRuleGroup,
  prepareRuleOrGroup,
  prismaFallback,
  prismaOperators,
  processMatchMode,
  queryBuilderStore,
  regenerateID,
  regenerateIDs,
  remove,
  rootPath,
  shouldRenderAsNumber,
  splitBy,
  sqlDialectPresets,
  standardClassnames,
  toArray,
  toFlatOptionArray,
  toFullOption,
  toFullOptionList,
  toFullOptionMap,
  toOptions,
  transformQuery,
  trimIfString,
  uniqByIdentifier,
  uniqByName,
  uniqOptGroups,
  uniqOptList,
  update,
  useControlledOrUncontrolled,
  useDeprecatedProps,
  useFields,
  useMatchModeEditor,
  useMergedContext,
  usePreferAnyProp,
  usePreferProp,
  usePrevious,
  useQueryBuilder,
  useQueryBuilderQuery,
  useQueryBuilderSchema,
  useQueryBuilderSelector,
  useQueryBuilderSetup,
  useReactDndWarning,
  useRule,
  useRuleGroup,
  useSelectElementChangeHandler,
  useStopEventPropagation,
  useValueEditor,
  useValueSelector
};
//# sourceMappingURL=react-querybuilder.legacy-esm.js.map