import type { RuleGroupType, RuleGroupTypeAny, RuleGroupTypeIC } from "../types/index.noReact.mjs";
/**
* Converts a {@link RuleGroupTypeIC} to {@link RuleGroupType}.
*
* This function is idempotent: {@link RuleGroupType} queries will be
* returned as-is.
*
* @group Query Tools
*/
export declare const convertFromIC: <RG extends RuleGroupType = RuleGroupType>(rg: RuleGroupTypeAny) => RG;
/**
* Converts a {@link RuleGroupType} to {@link RuleGroupTypeIC}.
*
* This function is idempotent: {@link RuleGroupTypeIC} queries will be
* returned as-is.
*
* @group Query Tools
*/
export declare const convertToIC: <RGIC extends RuleGroupTypeIC = RuleGroupTypeIC>(rg: RuleGroupTypeAny) => RGIC;
/**
* Converts a {@link RuleGroupType} to {@link RuleGroupTypeIC}. For a more explicit
* operation, use {@link convertToIC}.
*
* @group Query Tools
*/
declare function convertQuery(query: RuleGroupType): RuleGroupTypeIC;
/**
* Converts a {@link RuleGroupTypeIC} to {@link RuleGroupType}. For a more explicit
* operation, use {@link convertFromIC}.
*
* @group Query Tools
*/
declare function convertQuery(query: RuleGroupTypeIC): RuleGroupType;
export { convertQuery };
