/**
* Converts a given query object into one of the supported {@link index!ExportFormat ExportFormat} formats.
*
* @module formatQuery
*/
import type { RuleProcessor, ValueProcessorLegacy } from "../../types/index.noReact.mjs";
import { defaultRuleProcessorCEL } from "./defaultRuleProcessorCEL.mjs";
import { defaultRuleProcessorMongoDB } from "./defaultRuleProcessorMongoDB.mjs";
import { defaultRuleProcessorSpEL } from "./defaultRuleProcessorSpEL.mjs";
import { defaultValueProcessorByRule } from "./defaultValueProcessorByRule.mjs";
/**
* Default value processor used by {@link formatQuery} for "sql" format.
*
* @group Export
*/
export declare const defaultValueProcessor: ValueProcessorLegacy;
/**
* @deprecated Prefer {@link defaultRuleProcessorMongoDB}.
*
* @group Export
*/
export declare const defaultMongoDBValueProcessor: ValueProcessorLegacy;
/**
* @deprecated Prefer {@link defaultRuleProcessorCEL}.
*
* @group Export
*/
export declare const defaultCELValueProcessor: ValueProcessorLegacy;
/**
* @deprecated Prefer {@link defaultRuleProcessorSpEL}.
*
* @group Export
*/
export declare const defaultSpELValueProcessor: ValueProcessorLegacy;
export * from "./defaultRuleGroupProcessorCEL.mjs";
export * from "./defaultRuleGroupProcessorDrizzle.mjs";
export * from "./defaultRuleGroupProcessorElasticSearch.mjs";
export * from "./defaultRuleGroupProcessorJSONata.mjs";
export * from "./defaultRuleGroupProcessorJsonLogic.mjs";
export * from "./defaultRuleGroupProcessorLDAP.mjs";
export * from "./defaultRuleGroupProcessorMongoDB.mjs";
export * from "./defaultRuleGroupProcessorMongoDBQuery.mjs";
export * from "./defaultRuleGroupProcessorNL.mjs";
export * from "./defaultRuleGroupProcessorParameterized.mjs";
export * from "./defaultRuleGroupProcessorPrisma.mjs";
export * from "./defaultRuleGroupProcessorSequelize.mjs";
export * from "./defaultRuleGroupProcessorSpEL.mjs";
export * from "./defaultRuleGroupProcessorSQL.mjs";
export * from "./defaultRuleProcessorDrizzle.mjs";
export * from "./defaultRuleProcessorElasticSearch.mjs";
export * from "./defaultRuleProcessorJSONata.mjs";
export * from "./defaultRuleProcessorJsonLogic.mjs";
export * from "./defaultRuleProcessorLDAP.mjs";
export * from "./defaultRuleProcessorMongoDBQuery.mjs";
export * from "./defaultRuleProcessorNL.mjs";
export * from "./defaultRuleProcessorParameterized.mjs";
export * from "./defaultRuleProcessorPrisma.mjs";
export * from "./defaultRuleProcessorSequelize.mjs";
export * from "./defaultRuleProcessorSQL.mjs";
export * from "./defaultValueProcessorNL.mjs";
export * from "./formatQuery.mjs";
export * from "./utils.mjs";
export { defaultRuleProcessorCEL, defaultRuleProcessorMongoDB, defaultRuleProcessorSpEL, defaultValueProcessorByRule };
/**
* @deprecated Renamed to {@link defaultRuleProcessorCEL}.
*
* @group Export
*/
export declare const defaultValueProcessorCELByRule: RuleProcessor;
/**
* @deprecated Renamed to {@link defaultRuleProcessorMongoDB}.
*
* @group Export
*/
export declare const defaultValueProcessorMongoDBByRule: RuleProcessor;
/**
* @deprecated Renamed to {@link defaultRuleProcessorSpEL}.
*
* @group Export
*/
export declare const defaultValueProcessorSpELByRule: RuleProcessor;
