import type { FlexibleOption, FullField, GetOptionIdentifierType, MatchMode, MatchModeOptions } from "../types/index.noReact.mjs";
/**
* Utility function to get the match modes array for the given
* field. If the field definition does not define a `matchModes`
* property, the `getMatchModes` prop is used. Returns
* `FullOption<MatchMode>[]` of all match modes by default.
*/
export declare const getMatchModesUtil: <F extends FullField>(fieldData: F, getMatchModes?: (field: GetOptionIdentifierType<F>, misc: {
	fieldData: F;
}) => boolean | MatchMode[] | FlexibleOption<MatchMode>[]) => MatchModeOptions;
