/**
* Converts a value to lowercase if it's a string, otherwise returns the value as is.
*/
export declare const lc: <T>(v: T) => T;
/**
* Regex matching numeric strings. Passes for positive/negative integers, decimals,
* and E notation, with optional surrounding whitespace.
*/
export declare const numericRegex: RegExp;
/**
* Determines if a variable is a plain old JavaScript object, aka POJO.
*/
export declare const isPojo: (obj: any) => obj is Record<string, any>;
/**
* Simple helper to determine whether a value is null, undefined, or an empty string.
*/
export declare const nullOrUndefinedOrEmpty: (value: any) => value is null | undefined | "";
