import type { DefaultCombinatorName, DefaultOperatorName } from "../../types/index.noReact.mjs";
import type { SpELBaseNode, SpELBetweenFields, SpELBetweenValues, SpELBooleanLiteral, SpELCompoundNode, SpELExpressionNode, SpELIdentifier, SpELListNode, SpELNodeType, SpELNullLiteral, SpELNumericLiteral, SpELOpAnd, SpELOpMatches, SpELOpOr, SpELPrimitive, SpELProcessedExpression, SpELPropertyNode, SpELRelOpType, SpELRelation as SpELRelationOp, SpELStringLiteral } from "./types.mjs";
export declare const isSpELPropertyNode: (expr: SpELBaseNode<SpELNodeType>) => expr is SpELPropertyNode;
export declare const isSpELCompoundNode: (expr: SpELBaseNode<SpELNodeType>) => expr is SpELCompoundNode;
export declare const isSpELListNode: (expr: SpELBaseNode<SpELNodeType>) => expr is SpELListNode;
export declare const isSpELOpAnd: (expr: SpELProcessedExpression) => expr is SpELOpAnd;
export declare const isSpELOpOr: (expr: SpELProcessedExpression) => expr is SpELOpOr;
export declare const isSpELOpMatches: (expr: SpELProcessedExpression) => expr is SpELOpMatches;
export declare const isSpELIdentifier: (expr: SpELProcessedExpression) => expr is SpELIdentifier;
export declare const isSpELStringLiteral: (expr: SpELProcessedExpression) => expr is SpELStringLiteral;
export declare const isSpELNumericLiteral: (expr: SpELProcessedExpression) => expr is SpELNumericLiteral;
export declare const isSpELBooleanLiteral: (expr: SpELProcessedExpression) => expr is SpELBooleanLiteral;
export declare const isSpELNullLiteral: (expr: SpELProcessedExpression) => expr is SpELNullLiteral;
export declare const isSpELRelationOp: (expr: SpELProcessedExpression) => expr is SpELRelationOp;
export declare const isSpELPrimitive: (expr: SpELProcessedExpression) => expr is SpELPrimitive;
export declare const isSpELBetweenValues: (expr: SpELProcessedExpression) => expr is SpELBetweenValues;
export declare const isSpELBetweenFields: (expr: SpELProcessedExpression) => expr is SpELBetweenFields;
export declare const processCompiledExpression: (ce: SpELPropertyNode | SpELExpressionNode) => SpELProcessedExpression;
export declare const normalizeOperator: (opType: SpELRelOpType, flip?: boolean) => DefaultOperatorName;
export declare const generateFlatAndOrList: (expr: SpELProcessedExpression) => (DefaultCombinatorName | SpELProcessedExpression)[];
export declare const generateMixedAndOrList: (expr: SpELOpAnd | SpELOpOr) => (DefaultCombinatorName | SpELProcessedExpression | ("and" | SpELProcessedExpression)[])[];
