import type { FullCombinator, FullField, FullOperator, QueryBuilderProps, RuleGroupTypeAny } from "../types";
import type { UseQueryBuilderSchema } from "./QueryBuilder.useQueryBuilderSchema";
/**
* Calls {@link useQueryBuilderSetup} to massage the props and prepare basic
* update/generate methods, then passes the result to {@link useQueryBuilderSchema}
* to prepare and return all values required to render {@link QueryBuilder}.
*
* @group Hooks
*/
export declare const useQueryBuilder: <
	RG extends RuleGroupTypeAny,
	F extends FullField,
	O extends FullOperator,
	C extends FullCombinator
>(props: QueryBuilderProps<RG, F, O, C>) => UseQueryBuilderSchema<RG, F, O, C>;
