import type { Column, Operators, SQL, Table } from "drizzle-orm";
import type { RuleGroupProcessor } from "../../types/index.noReact";
/**
* Default rule group processor used by {@link formatQuery} for the "drizzle" format. The returned
* function can be assigned to the `where` property in the Drizzle relational queries API.
*
* @example
* const where = formatQuery(query, 'drizzle');
* const results = db.query.users.findMany({ where });
*
* @returns Function that takes a Drizzle table config and an object of Drizzle operators.
*
* @group Export
*/
export declare const defaultRuleGroupProcessorDrizzle: RuleGroupProcessor<(columns: Record<string, Column> | Table, drizzleOperators: Operators) => SQL | undefined>;
