import type { ParserCommonOptions } from "../../types/import";
import type { DefaultRuleGroupType, DefaultRuleGroupTypeIC, Except, RQBJsonLogic, RuleGroupTypeAny, RuleType } from "../../types/index.noReact";
/**
* Options object for {@link parseJsonLogic}.
*/
export interface ParseJsonLogicOptions extends ParserCommonOptions {
	jsonLogicOperations?: Record<string, (value: any) => RuleType | RuleGroupTypeAny | false>;
}
/**
* Converts a JsonLogic object into a query suitable for the
* {@link index!QueryBuilder QueryBuilder} component's `query` or `defaultQuery` props
* ({@link index!DefaultRuleGroupType DefaultRuleGroupType}).
*/
declare function parseJsonLogic(rqbJsonLogic: string | RQBJsonLogic): DefaultRuleGroupType;
/**
* Converts a JsonLogic object into a query suitable for the
* {@link index!QueryBuilder QueryBuilder} component's `query` or `defaultQuery` props
* ({@link index!DefaultRuleGroupType DefaultRuleGroupType}).
*/
declare function parseJsonLogic(rqbJsonLogic: string | RQBJsonLogic, options: Except<ParseJsonLogicOptions, "independentCombinators"> & {
	independentCombinators?: false;
}): DefaultRuleGroupType;
/**
* Converts a JsonLogic object into a query suitable for the
* {@link index!QueryBuilder QueryBuilder} component's `query` or `defaultQuery` props
* ({@link index!DefaultRuleGroupTypeIC DefaultRuleGroupTypeIC}).
*/
declare function parseJsonLogic(rqbJsonLogic: string | RQBJsonLogic, options: Except<ParseJsonLogicOptions, "independentCombinators"> & {
	independentCombinators: true;
}): DefaultRuleGroupTypeIC;
export { parseJsonLogic };
