import type { ParserCommonOptions } from "../../types/import";
import type { DefaultRuleGroupType, DefaultRuleGroupTypeIC, Except } from "../../types/index.noReact";
/**
* Options object for {@link parseSpEL!parseSpEL}.
*/
export interface ParseSpELOptions extends ParserCommonOptions {}
/**
* Converts a SpEL string expression into a query suitable for the
* {@link index!QueryBuilder QueryBuilder} component's `query` or `defaultQuery` props
* ({@link index!DefaultRuleGroupType DefaultRuleGroupType}).
*/
declare function parseSpEL(spel: string): DefaultRuleGroupType;
/**
* Converts a SpEL string expression into a query suitable for the
* {@link index!QueryBuilder QueryBuilder} component's `query` or `defaultQuery` props
* ({@link index!DefaultRuleGroupType DefaultRuleGroupType}).
*/
declare function parseSpEL(spel: string, options: Except<ParseSpELOptions, "independentCombinators"> & {
	independentCombinators?: false;
}): DefaultRuleGroupType;
/**
* Converts a SpEL string expression into a query suitable for the
* {@link index!QueryBuilder QueryBuilder} component's `query` or `defaultQuery` props
* ({@link index!DefaultRuleGroupTypeIC DefaultRuleGroupTypeIC}).
*/
declare function parseSpEL(spel: string, options: Except<ParseSpELOptions, "independentCombinators"> & {
	independentCombinators: true;
}): DefaultRuleGroupTypeIC;
export { parseSpEL };
